package com.project.survey.adapter;

import android.content.Context;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;

import com.project.survey.ui.approval.ApprovalActivity;
import com.project.survey.adapter.base.BaseAdapter;
import com.project.survey.adapter.viewholder.ApprovalWaitListViewHolder;
import com.project.survey.databinding.ItemApprovalWaitListBinding;
import com.project.survey.model.ApprovalBean;

/**
 * 流程审批 等待审批
 */
public class ApprovalWaitAdapter extends BaseAdapter<ApprovalWaitListViewHolder, ApprovalBean> {

    private final String type;

    public ApprovalWaitAdapter(Context context, String type) {
        super(context);
        this.type = type;
    }

    @NonNull
    @Override
    public ApprovalWaitListViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new ApprovalWaitListViewHolder(ItemApprovalWaitListBinding.inflate(getInflater(), parent, false));
    }

    @Override
    protected void onBindViewHolderDo(ApprovalWaitListViewHolder holder, int position) {
        ApprovalBean bean = mDataList.get(position);

        if (ApprovalActivity.PI_APPROVED.equals(type)) {
            holder.mBinding.ivAgree.setVisibility(View.VISIBLE);
        }


    }
}
