package com.project.survey.adapter;

import android.annotation.SuppressLint;
import android.content.Context;
import android.graphics.drawable.GradientDrawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.project.survey.R;
import com.project.survey.model.TextStyleBean;
import com.project.survey.util.DisplayUtils;

import java.util.List;

public class CustomRecycleTtemStyleDialogAdapter extends RecyclerView.Adapter<CustomRecycleTtemStyleDialogAdapter.ViewHolder> {

    private Context context;
    private List<TextStyleBean> list;
    private int mposition;
    private OnItemClickListener onClickListener;

    public CustomRecycleTtemStyleDialogAdapter(Context context, List<TextStyleBean> list, int selectedIndex) {
        this.context = context;
        this.list = list;
        mposition = selectedIndex;
    }

    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        ViewHolder holder = new ViewHolder(LayoutInflater.from(
                context).inflate(R.layout.layout_checkbox_item, parent,
                false));
        return holder;
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, @SuppressLint("RecyclerView") int position) {

        ViewGroup.LayoutParams layoutParams = holder.radio_type.getLayoutParams();
        layoutParams.width = 100;
        layoutParams.height = 50;
        holder.radio_type.setLayoutParams(layoutParams);

        holder.radio_type.setText(list.get(position).getText());

        if (list.get(position).getTextSize() > 0) {
            holder.radio_type.setTextSize(list.get(position).getTextSize());
        }
        if (list.get(position).getTextColor() > 0) {
            holder.radio_type.setTextColor(list.get(position).getTextColor());
        }

        GradientDrawable gradientDrawable = new GradientDrawable();
        gradientDrawable.setCornerRadii(new float[]{DisplayUtils.dip2px(3), DisplayUtils.dip2px(3), DisplayUtils.dip2px(3), DisplayUtils.dip2px(3),
                DisplayUtils.dip2px(3), DisplayUtils.dip2px(3), DisplayUtils.dip2px(3), DisplayUtils.dip2px(3)});
        gradientDrawable.setColor(list.get(position).getBackground());
        holder.radio_type.setBackgroundDrawable(gradientDrawable);

        if (position == mposition) {
            holder.iv_select_choose.setImageResource(R.mipmap.icon_checkbox_select);
        } else {
            holder.iv_select_choose.setImageResource(R.mipmap.icon_checkbox_unselect);
        }
        holder.itemView.setOnClickListener(v -> onClickListener.OnItemClick(position));
    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        ImageView iv_select_choose;
        TextView radio_type;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            iv_select_choose = itemView.findViewById(R.id.iv_select_choose);
            radio_type = itemView.findViewById(R.id.radio_type);
        }
    }

    public interface OnItemClickListener {
        void OnItemClick(int position);
    }

    public void setOnClickListener(OnItemClickListener onClickListener) {
        this.onClickListener = onClickListener;
    }
}
