package com.project.survey.logic.viewmodel

import androidx.lifecycle.LiveData
import androidx.lifecycle.MutableLiveData
import com.project.survey.model.CoordinateSystemData
import com.project.survey.network.RetrofitClient

class CoordinateSystemViewModel : BaseViewModel() {

    val api = RetrofitClient.createApiService()

    val uploadCoordinateSystemResponse: LiveData<String>
        get() = _uploadCoordinateSystemResponse
    private val _uploadCoordinateSystemResponse = MutableLiveData<String>()

    fun uploadCoordinateSystem(coordinateParameter: String, name: String) {
        launch {
            val res =
                api.uploadCoordinateSystem(coordinateParameter = coordinateParameter, name = name)
            if (res.success) {
                _uploadCoordinateSystemResponse.postValue(res.message)
            } else {
                errorResponse.postValue(res.message)
            }
        }
    }

    val downloadCoordinateSystemResponse: LiveData<List<CoordinateSystemData>>
        get() = _downloadCoordinateSystemResponse
    private val _downloadCoordinateSystemResponse = MutableLiveData<List<CoordinateSystemData>>()

    fun downloadCoordinateSystem() {
        launch {
            val res = api.downloadCoordinateSystem()
            if (res.success) {
                _downloadCoordinateSystemResponse.postValue(res.data)
            } else {
                errorResponse.postValue(res.message)
            }
        }
    }

    val updateCoordinateSystemResponse: LiveData<String>
        get() = _updateCoordinateSystemResponse
    private val _updateCoordinateSystemResponse = MutableLiveData<String>()

    fun updateCoordinateSystem(id: String, coordinateParameter: String, name: String) {
        launch {
            val res = api.updateCoordinateSystem(id, coordinateParameter, name)
            if (res.success) {
                _updateCoordinateSystemResponse.postValue(res.message)
            } else {
                errorResponse.postValue(res.message)
            }
        }
    }
}