package com.project.survey.model

import androidx.annotation.Keep
import com.project.survey.logic.bean.ListResult

@Keep
data class ApprovalResponse(
    val badges: Badge,
    val data: ListResult<ApprovalBean>?
)

@Keep
data class Badge(
    val PI_PREAPPROV: Int,
    val PI_APPROVED: Int,
    val PI_INFORMIEREN: Int,
    val PI_DELAY: Int,
    val PI_OWNER: Int
)

/**
 * {
 *      "id": "9234694fcda64ceb8ac88d4c8d66f47f",
 *      "title": "zlh（2024-09-26）发起【三标体系审批流程(施工单位提交)】",
 *      "context": "2024-09-26 14:02:38，由我【发起给冯毅山（监理单位负责人）】，意见：同意",
 *      "collect": "0",
 *      "delay": "0",
 *      "submitTime": "2024-09-26 14:02:38",
 *      "tableCode": "BD_SBTXWJZB",
 *      "funcCode": "BD_SBTXWJZB",
 *      "pkValue": "884febf5728544869fd80be90210c3b0",
 *      "submitUserId": null,
 *      "submitUserName": "zlh",
 *      "submitUserPhoto": "",
 *      "piid": "eeeba472-7bcc-11ef-b80c-00163ef452a9",
 *      "exigency": null,
 *      "isReadCode": null,
 *      "isReadName": null,
 *      "funcName": "三标体系文件",
 *      "urging": null
 * }
 */
@Keep
data class ApprovalBean(
    val id: String,
    val title: String,
    val context: String,
    val collect: String,
    val delay: String,
    val submitTime: String,
    val tableCode: String,
    val funcCode: String,
    val pkValue: String
)