package com.project.survey.model

import android.os.Parcelable
import androidx.annotation.Keep
import kotlinx.parcelize.Parcelize

/**
 * {
 *      "ZYLB_ZYLBZT_NAME": "执行中",
 *      "BD_ZYLB_ID": "9af7f594dfff4ab2b66a330873a17a19",
 *      "SY_CREATEUSERID": "HeRyydYjKz819ZLq9dw",
 *      "SY_GROUP_COMPANY_ID": "ROOT",
 *      "ZYLB_ZY_NAME": "放样2",
 *      "SY_COMPANY_ID": "V1R0gp2zJ3SvGFNvJdM",
 *      "ZYLB_FYSPJD": "2",
 *      "ZYLB_FYGCJD": "2",
 *      "SY_CREATEUSERNAME": "齐恒（施工1-1）",
 *      "SY_CREATETIME": "2024-11-01 10:45:08",
 *      "SY_ORG_ID": "systemdepartment",
 *      "ZYLB_CLY": "齐恒（施工单位1-2）",
 *      "ZYLB_ZYLBZT_CODE": "01",
 *      "ZYLB_ZYMS": "2",
 *      "BD_XMXX_ID": "xYgALS4VOJ0vDrEVUcQ",
 *      "ZYLB_CLY_ID": "2eab34c5248a4efe80ef12c370f2d5fa"
 *  }
 */
@Keep
@Parcelize
data class LoftingBean(
    val ZYLB_ZY_NAME: String, //作业名称
    val SY_CREATETIME: String, //创建时间
    val BD_ZYLB_ID: String, //作业ID
    val ZYLB_CLY: String, //测量员姓名
    val ZYLB_ZYMS: String,
    val ZYLB_FYSPJD: String, //放样水平精度
    val ZYLB_FYGCJD: String, //放样高程精度
): Parcelable
