package com.project.survey.model

import androidx.annotation.Keep

/**
 * CLJH_ 测量计划
 * GCJL_ 工程计量
 *
 *
 * 工程计量返回
 * {
 *     "BD_CONTRACT_ID": "",
 *     "GCJL_JLNR": "",
 *     "GCJL_SFWZDBW_CODE": "0",
 *     "BD_FBFXPZ_DWGCMC": "1号楼",
 *     "SY_COMPANY_ID": "V1R0gp2zJ3SvGFNvJdM",
 *     "GCJL_LCMC": "123",
 *     "BD_FBFXPZ_FXGCMC": "就餐区",
 *     "SY_CREATEUSERNAME": "admin123",
 *     "GCJL_SBDW_ID": "",
 *     "GCJL_SFWLHCL_CODE": "1",
 *     "CONTRACT_CODE": "",
 *     "SY_PREAPPROVUSERNAMES": "",
 *     "SY_CURRENTTASK": "",
 *     "BD_XMXX_ID": "xYgALS4VOJ0vDrEVUcQ",
 *     "GCJL_FL": "",
 *     "SY_CREATEUSERID": "b641884e6add456b83264163a8486337",
 *     "SY_GROUP_COMPANY_ID": "ROOT",
 *     "BD_FBFXPZ_DYGCBH": "DWGCBH2024101601",
 *     "GCJL_BDLSH": "CLJH2024103018",
 *     "SY_AUDFLAG": "NOSTATUS",
 *     "BF_FBFXPZ_FBGCBH": "FXGCJCQ2024101601",
 *     "GCJL_SBDW": "",
 *     "CONTRACT_NAME": "",
 *     "GCJL_ZT_CODE": "01",
 *     "GCJL_ZT_NAME": "草稿",
 *     "GCJL_LHCLDW_ID": "bd9a78b1-c307-475f-9442-3a80a80591f0",
 *     "BD_QYXX_ID": "",
 *     "SY_CREATETIME": "2024-10-30 11:16:34",
 *     "SY_ORG_ID": "systemdepartment",
 *     "BD_FBFXPZ_FBGCMC": "B1食堂",
 *     "BD_FBFXPZ_DWGCBH": "FXGCJCQ-ROW3-2024101601",
 *     "BD_CLGZ_GCJL_ID": "0954b1500f644fffa1d36671eb8436bd",
 *     "BD_FBFXPZ_DYGCMC": "3排8人区",
 *     "GCJL_SFWZDBW_NAME": "",
 *     "BD_FBFXPZ_FXGCBH": "FBGCB1202401"
 * }
 */
@Keep
data class MeasureBean(
    val BD_CONTRACT_ID: String,
    val BD_FBFXPZ_DWGCMC: String, //单位工程名称
    val SY_COMPANY_ID: String,
    val CLJH_ENDTIME: String,
    val BD_FBFXPZ_FXGCMC: String, //分项工程名称
    val SY_CREATEUSERNAME: String,
    val CLJH_SBDW_ID: String,
    val SY_PREAPPROVUSERNAMES: String,
    val SY_CURRENTTASK: String,
    val BD_CLJH_ID: String, //测量计划ID，即测量工作ID
    val CLJH_STARTTIME: String,
    val CLJH_CONTENT: String, //测量内容
    val CLJH_LCMC: String?, //流程名称
    val BD_FBFXPZ_FBGCMC: String, //分部工程名称
    val BD_FBFXPZ_DYGCMC: String, //单元工程名称
    val CLJH_BDLSH: String?, //流程编号
    val CLJH_CLLX_NAME: String, //测量类型
    // 无值或“待执行”为未开始测量，“执行中”为点击开始测量后至点击结束测量之间的状态，“已结束”为点击结束测量至点击生成报验单之间的状态，“报验单已生成”为生成报验单后的状态
    var CLJH_WORKSTATUS: String?, //状态
    val CLJH_WJSCLRY:String, //"齐恒（施工1-1）,立锋,"  根据当前账号名字是否在此字段

    val GCJL_LCMC: String?, //流程名称（工程计量）
    val GCJL_BDLSH: String?, //流程编号
    val GCJL_JLNR: String?, //计量内容
    val BD_CLGZ_GCJL_ID: String,
    val GCJL_WORKSTATUS: String? //状态
)
