package com.project.survey.model

import androidx.annotation.Keep
import com.bingce.data.surveyor.surveydata.pointsurvey.PointRecord
import com.bingce.device.Device
import com.bingce.device.enums.DeviceTypeEnum

@Keep
data class PointEntry(
    val name: String, //点名称 "点1"
    val workId: String, //测量工作id    "80ffa3b7701a46f9b320297e332d5678"
    val workType: String, //测量计划传BD_CLJH，工程计量传：BD_CLGZ_GCJL
    val antennaHight: String, //天线高 "11"
    val remark: String, //备注    "点1"
    val x: String,  //"111"
    val y: String,  //"11"
    val z: String,  //"11"
    val longitude: String, //经度
    val latitude: String, //纬度
    val hrms: String,
    val vrms: String,
    val pdop: String,
    val delay: String, //延迟 "xx"
    val jzt: String, //解状态  "xx"
    val satellite: String, //结算卫星   "xx"
) {
    constructor(record: PointRecord) : this(
        record.name,
        record.jobId,
        record.workType,
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_RTK) "${record.deviceInfoData.rtkStatusData?.poleHeight}" else "${record.deviceInfoData.tsStatusData?.hr}",
        record.remarks?:"",
        "${record.x}",
        "${record.y}",
        "${record.h}",
        "${record.longitude}",
        "${record.latitude}",
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_RTK) "${record.deviceInfoData.rtkStatusData?.hrms}" else "",
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_RTK) "${record.deviceInfoData.rtkStatusData?.vrms}" else "",
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_RTK) "${record.deviceInfoData.rtkStatusData?.pdop}" else "",
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_RTK) "${record.deviceInfoData.rtkStatusData?.diffAge}" else "",
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_RTK) record.deviceInfoData.rtkStatusData?.solutionState?:"" else "",
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_RTK) "${record.deviceInfoData.rtkStatusData?.satSolutionNum}" else ""
    )
}
