package com.project.survey.model

import android.os.Parcelable
import androidx.annotation.Keep
import kotlinx.android.parcel.Parcelize


/**
 * {
 *             "values": {
 *                 "XMXX_PILENO": "K1+000~K1+022",
 *                 "XMXX_INDUSTRYTYPE": "水电工程",
 *                 "SY_COMPANY_ID": null,
 *                 "SY_CREATEUSERNAME": null,
 *                 "XMXX_STATUS": "完工",
 *                 "XMXX_LEVEL": "B类",
 *                 "SY_ORDERINDEX": null,
 *                 "SY_GROUP_COMPANY_NAME": null,
 *                 "SY_COMPANY_NAME": null,
 *                 "XMXX_CODE": "XMBHTest20241014001",
 *                 "SY_CREATEORGID": null,
 *                 "SY_STATUS": "1",
 *                 "SY_CREATEUSERID": null,
 *                 "SY_GROUP_COMPANY_ID": null,
 *                 "XMXX_CONTACTNAME": "徐齐行",
 *                 "XMXX_LOCATIONXY": "121.1;29.6",
 *                 "XMXX_FILE": "[{\"fileKey\":\"imNMv698gNhK6K4savQ\",\"relName\":\"22ec2661b8cde194bd42900c99e46bef.jpg\",\"suffix\":\"jpg\",\"hasThumbnail\":true,\"fullUrl\":null,\"size\":59,\"createUserName\":\"admin123\",\"createUserDeptName\":\"北斗\",\"createTime\":\"2024-10-14 09:34:49\",\"createTimeStr\":\"2024-10-14 09:34:49\",\"dicId\":null,\"dicCode\":null,\"dicName\":null,\"remarks\":null}]",
 *                 "XMXX_ID": "xYgALS4VOJ0vDrEVUcQ",
 *                 "XMXX_CONTACTNAMEID": "",
 *                 "SY_CREATEORGNAME": null,
 *                 "XMXX_DESCRIPTION": "舟山市，古称海中洲，浙江省辖地级市 [2]，位于浙江省东北部舟山群岛 [1]，地处中国东南沿海，长江口南侧，杭州湾外缘的东海洋面上。 [95]地势由西南向东北倾斜，南部岛大，海拔高，排列密集，北部岛小，地势低，分布稀疏，四面环海；属亚热带季风气候；总面积2.22万平方千米，其中海域面积2.08万平方千米，4696个岛礁陆地总面积1440.2平方千米 [46]。截至2024年2月，舟山市下辖2个区、2个县。截至2023年末，舟山市常住人口为117.3万人。 [92]\n舟山市是中国第一个以群岛建制的地级市，地处中国东部黄金海岸线与长江黄金水道的交汇处，背靠长三角广阔经济腹地，舟山拥有2085个岛屿和270多公里深水岸线，是中国第一大群岛和重要港口城市。 [96]1953年6月10日，设立舟山专区；1987年1月，撤销舟山地区，建立舟山市。舟山市是长江三角洲中心区城市，上海大都市圈重要城市 [58]，也是中国第四个国家级新区舟山群岛新区所在地 [60]，是国际性的港口与海岛旅游城市 [62]，是海洋经济先导区 [62]，境内有由国务院批准设立的大宗商品交易管理与监督中心 [3]、中国（浙江）自由贸易试验区舟山片区 [61]。宁波舟山港年货物吞吐量位居全球第一，集装箱吞吐量位居世界第三。 [59]2024年，宁波舟山国际航运中心全球排名第8。 [106]舟山市拥有普陀山、嵊泗列岛两个国家级风景名胜区，岱山、桃花岛两个省级风景名胜区以及海岛历史文化名城定海。\n2023年，舟山市实现地区生产总值2100.8亿元，同比增长8.2%，高出全省平均2.2个百分点。",
 *                 "SY_CREATETIME": null,
 *                 "SY_ORG_ID": null,
 *                 "XMXX_NAME": "齐恒测试项目（舟山）"
 *             },
 *             "tenantIdField": "SY_TENANT_ID",
 *             "tenantNameField": "SY_TENANT_NAME",
 *             "tableCode": null,
 *             "pkCode": null,
 *             "pkValue": null
 *         }
 */
@Keep
@Parcelize
data class ProjectBean(
    val XMXX_NAME: String, //项目名称
    val XMXX_CODE: String, //项目编号
    val XMXX_LEVEL: String, //项目等级
    val XMXX_STATUS: String, //项目状态
    val XMXX_INDUSTRYTYPE: String, //行业类型
    val XMXX_PILENO: String, //起讫桩号
    val XMXX_CONTACTNAME: String, //联系人
    val XMXX_CONTACTNAMEID: String, //联系人ID
    val XMXX_LOCATIONXY: String, //项目位置(度) "121.1;29.6"
    val XMXX_FILE: String?, //项目图片
    val XMXX_DESCRIPTION: String?,
    val XMXX_ID: String, //项目ID
    val SY_STATUS: String?,
) : Parcelable

@Keep
@Parcelize
data class ProjectData(
    val tenantIdField: String,
    val tenantNameField: String,
    val values: ProjectBean
): Parcelable