package com.project.survey.network

import blankj.utilcode.util.AppUtils
import retrofit2.HttpException

object ExceptionHandle {

    fun handleException(e: Throwable): ResponseThrowable {
        if (AppUtils.isAppDebug()) {
            e.printStackTrace()
        }
        val ex: ResponseThrowable
        if (e is HttpException) {
            ex = when {
                e.code() == ERROR.AUTH_ERROR.code -> ResponseThrowable(ERROR.AUTH_ERROR, e)
//                e.code() == ERROR.PATH_ERROR.code -> ResponseThrowable(ERROR.PATH_ERROR, e)
//                e.code() == ERROR.SERVER_ERROR.code -> ResponseThrowable(ERROR.SERVER_ERROR, e)
//                e.code() == ERROR.BAD_GATEWAY.code -> ResponseThrowable(ERROR.BAD_GATEWAY, e)
                else -> ResponseThrowable(e.code(), e.message(), e)
            }
        } else {
            ex = if (!e.message.isNullOrEmpty()) ResponseThrowable(1000, e.message!!, e)
            else ResponseThrowable(ERROR.UNKNOWN, e)
        }
        return ex
    }
}