package com.project.survey.ui

import androidx.activity.viewModels
import androidx.fragment.app.viewModels
import com.project.survey.constants.SPConstants
import com.project.survey.databinding.ActivitySplashBinding
import com.project.survey.logic.viewmodel.MainViewModel
import com.project.survey.model.ProjectBean
import com.project.survey.ui.base.BaseBindingActivity
import com.project.survey.ui.login.LoginActivity
import com.project.survey.ui.project.ProjectListActivity
import com.project.survey.util.MockUtil
import com.project.survey.util.SPUtils

/**
 * 启动页
 */
class SplashActivity : BaseBindingActivity<ActivitySplashBinding>() {

    override fun getBinding(): ActivitySplashBinding = ActivitySplashBinding.inflate(layoutInflater)

    private val viewModel: MainViewModel by viewModels()

    override fun initView() {

    }

    override fun initData() {
        if (MockUtil.isTest){
            MockUtil.login()
            MainActivity.start()
        } else {
            if (SPUtils.getString(SPConstants.TOKEN).isBlank()) {
                LoginActivity.start()
            } else {
                val currentProject =
                    SPUtils.getParcelable(SPConstants.CURRENT_PROJECT, ProjectBean::class.java)
                if (currentProject == null) {
                    //未选择工程
                    ProjectListActivity.start()
                } else {
                    MainActivity.start()
                }
            }
        }
        finish()
    }

    override fun initListener() {

    }
}