package com.project.survey.ui.instrument.coordinatesystem

import android.content.Context
import android.view.ViewGroup
import com.bingce.coordlib.model.CoordinateSystem
import com.chad.library.adapter4.BaseQuickAdapter
import com.chad.library.adapter4.viewholder.QuickViewHolder
import com.project.survey.R
import com.project.survey.extend.setOnClickNoRepeatListener

class CoordinateSystemAdapter : BaseQuickAdapter<CoordinateSystem, QuickViewHolder>() {

    private var selectedPosition = -1
    private var lastPosition = -1

    override fun onBindViewHolder(holder: QuickViewHolder, position: Int, item: CoordinateSystem?) {
        if (item == null) return

        holder.setText(R.id.tvName, item.name)
            .setText(R.id.tvDescribe, item.country + "  " + item.projection.name)
        holder.itemView.isSelected = position == selectedPosition

        holder.itemView.setOnClickNoRepeatListener {
            holder.itemView.isSelected = true
            lastPosition = selectedPosition
            selectedPosition = position
            notifyItemChanged(lastPosition)
        }
    }

    fun getSelectedPosition(): Int = selectedPosition

    override fun onCreateViewHolder(
        context: Context,
        parent: ViewGroup,
        viewType: Int
    ): QuickViewHolder {
        return QuickViewHolder(R.layout.rv_item_coordinate_system, parent)
    }
}