package com.project.survey.ui.instrument.mobilestationmode;

import static androidx.recyclerview.widget.LinearLayoutManager.VERTICAL;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;

import androidx.annotation.Keep;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.Toolbar;
import androidx.recyclerview.widget.DefaultItemAnimator;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.bingce.device.Device;
import com.bingce.device.enums.ConnectTypeEnum;
import com.bingce.device.service.ntrip_sdk.CmccSdkService;
import com.bingce.device.service.ntrip_sdk.LuoWangSdkService;
import com.bingce.device.service.ntrip_sdk.NtripService;
import com.bingce.device.service.ntrip_sdk.QxwzSdkService;
import com.bingce.device.service.ntrip_sdk.SixentsSdkService;
import com.bingce.device.ui.adapter.GnssConfigAdapter;
import com.bingce.device.ui.utils.DeviceUtil;
import com.bingce.rtk.command.RTK;
import com.bingce.rtk.command.RtkCommand;
import com.bingce.rtk.command.alpha.AlphaRTK;
import com.bingce.rtk.command.comnav.ComNavRTK;
import com.bingce.rtk.command.daspatial.DasMiniRTK;
import com.bingce.rtk.command.devecent.DevecentRTK;
import com.bingce.rtk.command.fjd.FJDRTK;
import com.bingce.rtk.command.geo.GeoRTK;
import com.bingce.rtk.command.geomax.GeoMaxRTK;
import com.bingce.rtk.command.huace.HuaceRTK;
import com.bingce.rtk.command.icegps.IceGpsRTK;
import com.bingce.rtk.command.lianshi.LianshiRTK;
import com.bingce.rtk.command.quanfang.QuanFangRTK;
import com.bingce.rtk.command.qxlite.QxwzLiteRTK;
import com.bingce.rtk.command.qxwz.QxwzRTK;
import com.bingce.rtk.command.share.ShareRTK;
import com.bingce.rtk.command.south.SouthRTK;
import com.bingce.rtk.command.spectra.SpectraRTK;
import com.bingce.rtk.command.tersus.TersusRTK;
import com.bingce.rtk.command.xinyue.XinYueRTK;
import com.bingce.rtk.command.zhd_new.ZhdNewRTK;
import com.bingce.rtk.command.zhd_old.ZhdOldRTK;
import com.bingce.rtk.config.GnssConfig;
import com.bingce.rtk.config.GnssConfigManager;
import com.bingce.rtk.enums.DataLinkModeEnum;
import com.bingce.rtk.enums.WorkModeEnum;
import com.bingce.rtk.event.RtkStartCmccServiceEvent;
import com.bingce.rtk.event.RtkStartLuoWangServiceEvent;
import com.bingce.rtk.event.RtkStartNtripServiceEvent;
import com.bingce.rtk.event.RtkStartQxwzSdkServiceEvent;
import com.bingce.rtk.event.RtkStartSixentsServiceEvent;
import com.bingce.rtk.gnss.Gnss;
import com.bingce.rtk.util.GnssUtil;
import com.bingce.surveyor.agentweb.HelpWebActivity;
import com.bingce.utils.Util;
import com.project.survey.R;
import com.project.survey.ui.instrument.mobilestationmode.base.ComnavRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.DevecentRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.FJDRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.GeoRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.GeomaxRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.HuaceRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.IceGpsRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.LianshiRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.QxwzRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.SouthRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.SpectraRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.TersusRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.base.ZhdRtkBaseSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.ComnavRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.DevecentRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.FJDRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.GeoRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.GeomaxRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.HuaceRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.IceGpsRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.LianshiRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.QxwzLiteQuanFangRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.QxwzRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.SouthRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.SpectraRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.TersusRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.rover.ZhdRtkRoverSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.staticc.ComnavRtkStaticSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.staticc.FjdRtkStaticSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.staticc.GeoRtkStaticSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.staticc.HuaceRtkStaticSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.staticc.SouthRtkStaticSettingActivity;
import com.project.survey.ui.instrument.mobilestationmode.staticc.ZhdRtkStaticSettingActivity;

import org.greenrobot.eventbus.EventBus;
import org.polaric.colorful.ColorfulActivity;

import blankj.utilcode.util.ServiceUtils;
import blankj.utilcode.util.ToastUtils;

@Keep
public class GnssConfigSetActivity extends ColorfulActivity implements GnssConfigAdapter.onSlidingViewClickListener {
    private Toolbar mToolbar;
    public RecyclerView recyclerView;
    public Button mBtnCreate;
    public Button mBtnApply;
    public Button mBtnStopStatic;
    GnssConfigAdapter adapter;
    private int apply_position;
    private WorkModeEnum sysMode;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_gnss_config_set);
        mToolbar = findViewById(R.id.toolbar);
        recyclerView = findViewById(R.id.recyclerView);
        mBtnCreate = findViewById(R.id.activity_gnss_config_set_create);
        mBtnApply = findViewById(R.id.activity_gnss_config_set_apply);
        mBtnStopStatic = findViewById(R.id.activity_gnss_config_set_stop_static);
        setSupportActionBar(mToolbar);
        if (getSupportActionBar() != null)
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        int type = getIntent().getIntExtra("sysMode", 0);
        switch (type) {
            case 1:
                sysMode = WorkModeEnum.BASE;
                setTitle(getResources().getString(R.string.base_mode));
                mBtnStopStatic.setVisibility(View.GONE);
                String current_base_config_id = Util.getStringPreference("current_base_config_id", "");
                for (int i = 0; i < GnssConfigManager.getInstance().getBaseConfigList().size(); i++) {
                    if (current_base_config_id.equals(GnssConfigManager.getInstance().getBaseConfigList().get(i).getId())) {
                        apply_position = i;
                        break;
                    }
                }
                break;
            case 2:
                sysMode = WorkModeEnum.STATIC;
                setTitle(getResources().getString(R.string.static_mode));
                mBtnStopStatic.setVisibility(View.VISIBLE);
                String current_static_config_id = Util.getStringPreference("current_static_config_id", "");
                for (int i = 0; i < GnssConfigManager.getInstance().getStaticConfigList().size(); i++) {
                    if (current_static_config_id.equals(GnssConfigManager.getInstance().getStaticConfigList().get(i).getId())) {
                        apply_position = i;
                        break;
                    }
                }
                break;
            default:
                sysMode = WorkModeEnum.ROVER;
                setTitle(getResources().getString(R.string.rover_mode));
                mBtnStopStatic.setVisibility(View.GONE);
                String current_rover_config_id = Util.getStringPreference("current_rover_config_id", "");
                for (int i = 0; i < GnssConfigManager.getInstance().getRoverConfigList().size(); i++) {
                    if (current_rover_config_id.equals(GnssConfigManager.getInstance().getRoverConfigList().get(i).getId())) {
                        apply_position = i;
                        break;
                    }
                }
        }

        mBtnCreate.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                switch (sysMode) {
                    case ROVER:
                        roverSetting(-1);
                        break;
                    case BASE:
                        baseSetting(-1);
                        break;
                    case STATIC:
                        staticSetting(-1);
                        break;
                }
            }
        });
        mBtnApply.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!Device.getInstance().isDeviceConnected()) {
                    ToastUtils.showShort(R.string.rtk_not_connected);
                    return;
                }
                ServiceUtils.stopService(NtripService.class);
                ServiceUtils.stopService(QxwzSdkService.class);
                ServiceUtils.stopService(CmccSdkService.class);
                ServiceUtils.stopService(LuoWangSdkService.class);
                ServiceUtils.stopService(SixentsSdkService.class);
                GnssConfig gnssConfig;
                switch (sysMode) {
                    case ROVER:
                        if (apply_position >= 0 && apply_position < GnssConfigManager.getInstance().getRoverConfigList().size()) {
                            gnssConfig = GnssConfigManager.getInstance().getRoverConfigList().get(apply_position);
                            GnssUtil.config2Gnss(gnssConfig);
                            Gnss.getInstance().save();
                            Util.putPreference("current_rover_config_id", gnssConfig.getId(), true);
                            if (gnssConfig.getDevice().getCurDataLink() == DataLinkModeEnum.PHONE && !(RTK.getInstance() instanceof QxwzRTK)) {
                                switch (gnssConfig.getNetwork().getMode()) {
                                    case NTRIP:
                                    case BASE_SN:
                                        EventBus.getDefault().post(new RtkStartNtripServiceEvent());
                                        break;
                                    case QXWZ_SDK:
                                        EventBus.getDefault().post(new RtkStartQxwzSdkServiceEvent());
                                        break;
                                    case SIXENTS_SDK:
                                        EventBus.getDefault().post(new RtkStartSixentsServiceEvent());
                                        break;
                                    case CMCC_SDK:
                                        EventBus.getDefault().post(new RtkStartCmccServiceEvent());
                                        break;
                                    case LUOWANG_SDK:
                                        EventBus.getDefault().post(new RtkStartLuoWangServiceEvent());
                                        break;
                                }
                            }
                            if (Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_SPP
                                    || Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_BLE
                                    || Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_QXBT) {
                                Device.getInstance().rtkSendCommand(RtkCommand.getInstance().setRover(true));
                            }
                        } else {
                            ToastUtils.showShort(R.string.please_choose_config_first);
                        }
                        break;
                    case BASE:
                        if (apply_position >= 0 && apply_position < GnssConfigManager.getInstance().getBaseConfigList().size()) {
                            gnssConfig = GnssConfigManager.getInstance().getBaseConfigList().get(apply_position);
                            GnssUtil.config2Gnss(gnssConfig);
                            Gnss.getInstance().save();
                            Util.putPreference("current_base_config_id", gnssConfig.getId(), true);
                            if (Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_SPP
                                    || Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_BLE
                                    || Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_QXBT) {
                                Device.getInstance().rtkSendCommand(RtkCommand.getInstance().setBase());
                            }
                        } else {
                            ToastUtils.showShort(R.string.please_choose_config_first);
                        }
                        break;
                    case STATIC:
                        if (apply_position >= 0 && apply_position < GnssConfigManager.getInstance().getStaticConfigList().size()) {
                            gnssConfig = GnssConfigManager.getInstance().getStaticConfigList().get(apply_position);
                            GnssUtil.config2Gnss(gnssConfig);
                            Gnss.getInstance().save();
                            Util.putPreference("current_static_config_id", gnssConfig.getId(), true);
                            if (Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_SPP
                                    || Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_BLE
                                    || Device.getInstance().connectType == ConnectTypeEnum.CONNECT_TYPE_QXBT) {
                                Device.getInstance().rtkSendCommand(RtkCommand.getInstance().setStatic());
                            }
                        } else {
                            ToastUtils.showShort(R.string.please_choose_config_first);
                        }
                        break;
                }
            }
        });

        mBtnStopStatic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                ToastUtils.showShort(R.string.stop_static);
                RTK.getInstance().sendStopStaticCmd();
            }
        });

        if (adapter == null) {
            adapter = new GnssConfigAdapter(this, sysMode);
            LinearLayoutManager linearLayoutManager = new LinearLayoutManager(this);
            linearLayoutManager.setOrientation(VERTICAL);
            recyclerView.setLayoutManager(linearLayoutManager);
            recyclerView.setAdapter(adapter);
            recyclerView.setItemAnimator(new DefaultItemAnimator());
        } else {
            adapter.notifyDataSetChanged();
        }
        adapter.setOnSlidListener(this);
    }

    private void baseSetting(int gnssConfigIndex) {
        if (Device.getInstance().isDeviceConnected() || DeviceUtil.isDebug()) {
            Intent intent = new Intent();
            if (gnssConfigIndex >= 0)
                intent.putExtra("gnssConfigIndex", gnssConfigIndex);
            if (RTK.getInstance() instanceof GeoRTK
                    || RTK.getInstance() instanceof AlphaRTK) {
                intent.setClass(GnssConfigSetActivity.this, GeoRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof ZhdNewRTK
                    || RTK.getInstance() instanceof ZhdOldRTK) {
                intent.setClass(GnssConfigSetActivity.this, ZhdRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof HuaceRTK) {
                intent.setClass(GnssConfigSetActivity.this, HuaceRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof SouthRTK) {
                intent.setClass(GnssConfigSetActivity.this, SouthRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof ComNavRTK) {
                intent.setClass(GnssConfigSetActivity.this, ComnavRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof GeoMaxRTK) {
                intent.setClass(GnssConfigSetActivity.this, GeomaxRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof IceGpsRTK) {
                intent.setClass(GnssConfigSetActivity.this, IceGpsRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof LianshiRTK) {
                intent.setClass(GnssConfigSetActivity.this, LianshiRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof TersusRTK) {
                intent.setClass(GnssConfigSetActivity.this, TersusRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof SpectraRTK) {
                intent.setClass(GnssConfigSetActivity.this, SpectraRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof DevecentRTK) {
                intent.setClass(GnssConfigSetActivity.this, DevecentRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof FJDRTK) {
                intent.setClass(GnssConfigSetActivity.this, FJDRtkBaseSettingActivity.class);
            } else if (RTK.getInstance() instanceof QxwzRTK) {
                intent.setClass(GnssConfigSetActivity.this, QxwzRtkBaseSettingActivity.class);
            } else {
                ToastUtils.showShort(R.string.current_rtk_type_not_support_this_action);
                return;
            }

            if (intent.getComponent() != null) {
                startActivityForResult(intent, 1);
            }
        } else {
            ToastUtils.showShort(R.string.device_connect_lost);
        }
    }

    private void roverSetting(int gnssConfigIndex) {
        if (Device.getInstance().isDeviceConnected() || DeviceUtil.isDebug()) {
            Intent intent = new Intent();
            if (gnssConfigIndex >= 0)
                intent.putExtra("gnssConfigIndex", gnssConfigIndex);

            if (RTK.getInstance() instanceof GeoRTK
                    || RTK.getInstance() instanceof AlphaRTK
                    || RTK.getInstance() instanceof ShareRTK) {
                intent.setClass(GnssConfigSetActivity.this, GeoRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof ZhdNewRTK
                    || RTK.getInstance() instanceof ZhdOldRTK) {
                intent.setClass(GnssConfigSetActivity.this, ZhdRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof HuaceRTK) {
                intent.setClass(GnssConfigSetActivity.this, HuaceRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof SouthRTK) {
                intent.setClass(GnssConfigSetActivity.this, SouthRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof ComNavRTK) {
                intent.setClass(GnssConfigSetActivity.this, ComnavRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof GeoMaxRTK) {
                intent.setClass(GnssConfigSetActivity.this, GeomaxRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof IceGpsRTK) {
                intent.setClass(GnssConfigSetActivity.this, IceGpsRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof LianshiRTK) {
                intent.setClass(GnssConfigSetActivity.this, LianshiRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof TersusRTK) {
                intent.setClass(GnssConfigSetActivity.this, TersusRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof SpectraRTK) {
                intent.setClass(GnssConfigSetActivity.this, SpectraRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof DevecentRTK) {
                intent.setClass(GnssConfigSetActivity.this, DevecentRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof FJDRTK) {
                intent.setClass(GnssConfigSetActivity.this, FJDRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof QxwzRTK) {
                intent.setClass(GnssConfigSetActivity.this, QxwzRtkRoverSettingActivity.class);
            } else if (RTK.getInstance() instanceof QxwzLiteRTK
                    || RTK.getInstance() instanceof QuanFangRTK
                    || RTK.getInstance() instanceof DasMiniRTK
                    || RTK.getInstance() instanceof XinYueRTK) {
                intent.setClass(GnssConfigSetActivity.this, QxwzLiteQuanFangRtkRoverSettingActivity.class);
            } else {
                ToastUtils.showShort(R.string.current_rtk_type_not_support_this_action);
                return;
            }
            if (intent.getComponent() != null) {
                startActivityForResult(intent, 0);
            }
        } else {
            ToastUtils.showShort(R.string.device_connect_lost);
        }
    }

    private void staticSetting(int gnssConfigIndex) {
        if (Device.getInstance().isDeviceConnected() || DeviceUtil.isDebug()) {
            Intent intent = new Intent();
            if (gnssConfigIndex >= 0)
                intent.putExtra("gnssConfigIndex", gnssConfigIndex);

            if (RTK.getInstance() instanceof GeoRTK || RTK.getInstance() instanceof AlphaRTK) {
                intent.setClass(GnssConfigSetActivity.this, GeoRtkStaticSettingActivity.class);
            } else if (RTK.getInstance() instanceof ZhdNewRTK
                    || RTK.getInstance() instanceof ZhdOldRTK) {
                intent.setClass(GnssConfigSetActivity.this, ZhdRtkStaticSettingActivity.class);
            } else if (RTK.getInstance() instanceof HuaceRTK) {
                intent.setClass(GnssConfigSetActivity.this, HuaceRtkStaticSettingActivity.class);
            } else if (RTK.getInstance() instanceof SouthRTK) {
                intent.setClass(GnssConfigSetActivity.this, SouthRtkStaticSettingActivity.class);
            } else if (RTK.getInstance() instanceof ComNavRTK) {
                intent.setClass(GnssConfigSetActivity.this, ComnavRtkStaticSettingActivity.class);
            } else if (RTK.getInstance() instanceof FJDRTK) {
                intent.setClass(GnssConfigSetActivity.this, FjdRtkStaticSettingActivity.class);
            } else {
                ToastUtils.showShort(R.string.current_rtk_type_not_support_this_action);
                return;
            }
            if (intent.getComponent() != null) {
                startActivityForResult(intent, 2);
            }
        } else {
            ToastUtils.showShort(R.string.device_connect_lost);
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
//        if (sysMode == WorkModeEnum.ROVER || sysMode == WorkModeEnum.BASE) {
//            getMenuInflater().inflate(R.menu.menu_activity_rtk_station, menu);
//        }
        return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                break;
            case R.id.menu_help:
                HelpWebActivity.navigation2RtkStationHelp(this, sysMode);
                break;
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (adapter != null) {
            adapter.updateCurrentId();
            adapter.notifyDataSetChanged();
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        EventBus.getDefault().unregister(this);
    }

    @Override
    public void onItemClick(WorkModeEnum workMode, int position) {
        apply_position = position;
    }

    @Override
    public void onDeleteBtnClick(WorkModeEnum workMode, int position) {
        adapter.removeData(position);
    }

    @Override
    public void onEditBtnClick(WorkModeEnum workMode, int position) {
        switch (workMode) {
            case ROVER:
                roverSetting(position);
                break;
            case BASE:
                baseSetting(position);
                break;
            case STATIC:
                staticSetting(position);
                break;
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK && data != null) {
            boolean isReturnHome = data.getBooleanExtra("isReturnHome", false);
            if (isReturnHome) {
                Intent intent = new Intent();
                intent.putExtra("isReturnHome", true);
                setResult(Activity.RESULT_OK, intent);
                finish();
            }
        }
    }
}