package com.project.survey.ui.instrument.mobilestationmode.base;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;

import androidx.annotation.Keep;
import androidx.appcompat.widget.Toolbar;
import androidx.fragment.app.Fragment;

import com.bingce.device.ui.rtk.RtkBaseSettingFragment;
import com.bingce.device.ui.utils.DeviceUtil;
import com.bingce.rtk.command.RTK;
import com.bingce.rtk.command.qxwz.QxwzRTK;
import com.project.survey.R;

import org.polaric.colorful.ColorfulActivity;


@Keep
public abstract class AbstractRtkBaseSettingActivity extends ColorfulActivity {
    protected Button mBtnSaveApply, mBtnSave;

    public void initUiSetting(Fragment fragment) {

    }

    @SuppressLint("SourceLockedOrientationActivity")
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_rtk_base_setting);
        Toolbar mToolbar = findViewById(R.id.toolbar);
        setSupportActionBar(mToolbar);
        if (getSupportActionBar() != null)
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        RtkBaseSettingFragment fragment = new RtkBaseSettingFragment();
        setBasePositionClickListener(fragment);
        initUiSetting(fragment);

        getSupportFragmentManager()
                .beginTransaction()
                .add(R.id.activity_rtk_base_setting_fragment, fragment)
                .commit();

        mBtnSave = findViewById(R.id.activity_base_setting_btn_save);
        mBtnSaveApply = findViewById(R.id.activity_base_setting_btn_save_apply);

        mBtnSave.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                RtkBaseSettingFragment fragment = getBaseFragment();
                if (fragment != null) {
                    if (fragment.saveSettings()) {
                        finish();
                    }
                }
            }
        });

        mBtnSaveApply.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                RtkBaseSettingFragment fragment = getBaseFragment();
                if (fragment != null) {
                    if (fragment.saveSettings()) {
                        fragment.apply();
                        if (RTK.getInstance() instanceof QxwzRTK) {//千寻的设备没有进度条对话框，所以直接返回上一界面
                            finish();
                        }
                    }
                }
            }
        });
    }

    public RtkBaseSettingFragment getBaseFragment() {
        Fragment fragment = DeviceUtil.getCurrentFragment(this, R.id.activity_rtk_base_setting_fragment);
        if (fragment instanceof RtkBaseSettingFragment) {
            return (RtkBaseSettingFragment) fragment;
        }
        return null;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int itemId = item.getItemId();
        if (itemId == android.R.id.home) {
            finish();
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case KeyEvent.KEYCODE_BACK:
                finish();
                break;
        }
        return true;
    }

    protected abstract void setBasePositionClickListener(RtkBaseSettingFragment fragment);
}
