package com.project.survey.ui.instrument.mobilestationmode.base;

import android.graphics.Color;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;

import androidx.annotation.WorkerThread;

import com.bingce.coordlib.model.Blh;
import com.bingce.coordlib.model.BlhCoordinatePair;
import com.bingce.coordlib.model.Coordinate;
import com.bingce.coordlib.model.CoordinateSystem;
import com.bingce.device.Device;
import com.bingce.device.ui.AbstractSurveyActivity;
import com.bingce.utils.ColorUtil;
import com.bingce.utils.IOnSingleGetCallback;
import com.bingce.utils.SoftKeyUtils;
import com.bingce.utils.ThreadPoolUtil;
import com.bingce.utils.Util;
import com.daimajia.numberprogressbar.NumberProgressBar;
import com.rengwuxian.materialedittext.MaterialEditText;

import blankj.utilcode.util.ToastUtils;
import device.ui.Rid;
import device.ui.Rlayout;
import device.ui.Rstring;

public abstract class AbstractRtkMatchingPointsActivity extends AbstractSurveyActivity {
    private EditText et_0;
    private MaterialEditText met_b, met_l, met_h, met_name, met_x, met_y, met_z;
    private Button mBtnCollect, mBtnSave;
    private CheckBox mCheckUseH, mCheckUseV;
    private CoordinateSystem coordinateSystem;
    private int mTimes = -1, position = -1;
    private double mSumB, mSumL, mSumH;
    private View mBtnOpen1, mBtnOpen2;
    private double b, l, h, x, y, z;
    private NumberProgressBar progressBar;
//    protected final CachedCurrentCoordinateSystem cachedCoordinateSystem = new CachedCurrentCoordinateSystem(this);

    @Override
    protected int getLayoutId() {
        return Rlayout.activity_rtk_matching_points();
    }

    @Override
    protected void initView() {
        position = getIntent().getIntExtra("position", -1);
        et_0 = findViewById(Rid.activity_rtk_matching_points_et_0());
        met_b = findViewById(Rid.activity_rtk_matching_points_met_b());
        met_l = findViewById(Rid.activity_rtk_matching_points_met_l());
        met_h = findViewById(Rid.activity_rtk_matching_points_met_h());
        met_name = findViewById(Rid.activity_rtk_matching_points_met_name());
        met_x = findViewById(Rid.activity_rtk_matching_points_met_x());
        met_y = findViewById(Rid.activity_rtk_matching_points_met_y());
        met_z = findViewById(Rid.activity_rtk_matching_points_met_z());
        mBtnOpen1 = findViewById(Rid.activity_rtk_matching_points_btn_open1());
        mBtnOpen2 = findViewById(Rid.activity_rtk_matching_points_btn_open2());
        mBtnCollect = findViewById(Rid.activity_rtk_matching_points_btn_collect());
        mBtnSave = findViewById(Rid.activity_rtk_matching_points_btn_save());
        mCheckUseH = findViewById(Rid.activity_rtk_matching_points_cb_use_horizontal());
        mCheckUseV = findViewById(Rid.activity_rtk_matching_points_cb_use_vertical());
        progressBar = findViewById(Rid.activity_rtk_matching_points_progressbar());
        progressBar.setReachedBarColor(ColorUtil.getColorPrimary(this));

        mBtnCollect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
//                et_0.requestFocus();//作用：输入框不聚焦，防止实测坐标后页面自动滑动到顶部，同样避免RTK继续后输入框没有失效焦点，导致再输入内容输入法自动隐藏的问题
//                CommonUtils.hideSoftInput();
                SoftKeyUtils.hideSoftKey();

                Device.getInstance().isRtkRunning = true;
                mTimes = 0;
                mSumB = 0;
                mSumL = 0;
                mSumH = 0;
                met_b.setText("");
                met_l.setText("");
                met_h.setText("");
                progressBar.setProgress(0);
            }
        });
        mBtnSave.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
//                et_0.requestFocus();//作用：输入框不聚焦，防止实测坐标后页面自动滑动到顶部
//                CommonUtils.hideSoftInput();
                SoftKeyUtils.hideSoftKey();
                if (checkActionEnable()) {
                    x = Double.parseDouble(met_x.getText().toString());
                    y = Double.parseDouble(met_y.getText().toString());
                    z = Double.parseDouble(met_z.getText().toString());
                    b = Math.toDegrees(Util.dmsStringToRadian(met_b.getText().toString(), false));
                    l = Math.toDegrees(Util.dmsStringToRadian(met_l.getText().toString(), false));
                    h = Double.parseDouble(met_h.getText().toString());

                    if (position >= 0 && position < coordinateSystem.getPairs().size()) {
                        coordinateSystem.getPairs().set(position, new BlhCoordinatePair(met_name.getText().toString(), new Blh(b, l, h), new Coordinate(x, y, z), mCheckUseH.isChecked(), mCheckUseV.isChecked()));
                    } else {
                        coordinateSystem.getPairs().add(new BlhCoordinatePair(met_name.getText().toString(), new Blh(b, l, h), new Coordinate(x, y, z), mCheckUseH.isChecked(), mCheckUseV.isChecked()));
                    }
                    ThreadPoolUtil.execute(() -> {
//                        ProjectDb.getInstance().updateCurrentCoordinator(coordinateSystem);
                        save(coordinateSystem);
                        runOnUiThread(() -> {
                            setResult(RESULT_OK);
                            finish();
                        });
                    });
                }
            }
        });
        // 隐藏，通过平滑采集获取
        mBtnOpen1.setVisibility(View.GONE);
        mBtnOpen1.setOnClickListener(view -> {
            et_0.requestFocus();
            SoftKeyUtils.hideSoftKey();
            selectBLH();
//            CommonUtils.hideSoftInput();
//            new MaterialDialog.Builder(RtkMatchingPointsActivity.this)
//                    .title(Rstring.data_source)
//                    .items(new String[]{getString(Rstring.point_survey_point_library)})
//                    .itemsCallback((dialog, itemView, which, text) -> {
//                        switch (which) {
//                            case 0:
//                                CoordinatePointsLibraryActivity.pickPoint(this, (name, code, x, y, z, b, l, h) -> {
//                                    onPicked(b, l, h);
//                                });
//                                break;
//                        }
//                    }).show();
        });
        mBtnOpen2.setOnClickListener(view -> {
            et_0.requestFocus();
            SoftKeyUtils.hideSoftKey();
            selectXYZ();
//            CommonUtils.hideSoftInput();
//            new MaterialDialog.Builder(RtkMatchingPointsActivity.this)
//                    .title(Rstring.data_source)
//                    .items(new String[]{getString(Rstring.road_control_point), getString(Rstring.global_control_point), getString(Rstring.point_survey_point_library), getString(Rstring.staking_point_library)})
//                    .itemsCallback((dialog, itemView, which, text) -> {
//                        switch (which) {
//                            case 0:
//                                ControlPointsNewActivity.pickPoint(this, false, (name, code, x, y, z, remarks) -> {
//                                    onPicked(name, x, y, z);
//                                });
//                                break;
//                            case 1:
//                                ControlPointsNewActivity.pickPoint(this, true, (name, code, x, y, z, remarks) -> {
//                                    onPicked(name, x, y, z);
//                                });
//                                break;
//                            case 2:
//                                CoordinatePointsLibraryActivity.pickPoint(this, (name, code, x, y, z, b, l, h) -> {
//                                    onPicked(name, x, y, z);
//                                });
//                                break;
//                            case 3:
//                                StakingJobActivity.pickPoint(this, (name, x, y, z) -> {
//                                    onPicked(name, x, y, z);
//                                });
//                                break;
//                        }
//                    }).show();
        });
        initMaterialEditTextColor();

//        cachedCoordinateSystem.observe(new AbstractCachedObserver<CoordinateSystem>() {
//            @Override
//            public void onChanged(boolean isFirstTimeDataChanged, CoordinateSystem coordinateSystem) {
//                if (isFirstTimeDataChanged) {
//                    init(coordinateSystem);
//                }
//            }
//        });
        loadCurrentCoordinateSystem(this::init);
    }

    protected void init(CoordinateSystem system) {
        coordinateSystem = system;
        if (position >= 0 && position < coordinateSystem.getPairs().size()) {
            b = coordinateSystem.getPairs().get(position).getBlh().getLatitude();
            l = coordinateSystem.getPairs().get(position).getBlh().getLongitude();
            h = coordinateSystem.getPairs().get(position).getBlh().getAltitude();
            x = coordinateSystem.getPairs().get(position).getCoordinate().getX();
            y = coordinateSystem.getPairs().get(position).getCoordinate().getY();
            z = coordinateSystem.getPairs().get(position).getCoordinate().getZ();
            met_b.setText(Util.radianToDmsDoubleString(Math.toRadians(b), 6, false));
            met_l.setText(Util.radianToDmsDoubleString(Math.toRadians(l), 6, false));
            met_h.setText(Util.formatDouble2StringDotAuto(h));
            met_name.setText(coordinateSystem.getPairs().get(position).getName());
            met_x.setText(Util.formatDouble2StringDotAuto(x));
            met_y.setText(Util.formatDouble2StringDotAuto(y));
            met_z.setText(Util.formatDouble2StringDotAuto(z));
            mCheckUseH.setChecked(coordinateSystem.getPairs().get(position).isUseH());
            mCheckUseV.setChecked(coordinateSystem.getPairs().get(position).isUseV());
        }
    }

    @Override
    protected void initData() {

    }

    protected final void onPicked(double b, double l, double h) {
        met_b.setText(Util.radianToDmsDoubleString(Math.toRadians(b), 6, false));
        met_l.setText(Util.radianToDmsDoubleString(Math.toRadians(l), 6, false));
        met_h.setText(Util.formatDouble2StringDotAuto(h));
        ToastUtils.showShort(Rstring.open_point_successful());
    }

    final protected void onPicked(String name, double x, double y, double z) {
        if (name != null) met_name.setText(name);
        met_x.setText(Util.formatDouble2StringDotAuto(x));
        met_y.setText(Util.formatDouble2StringDotAuto(y));
        met_z.setText(Util.formatDouble2StringDotAuto(z));
        ToastUtils.showShort(Rstring.open_point_successful());
    }

    private boolean checkActionEnable() {
        if (!mCheckUseH.isChecked() && !mCheckUseV.isChecked()) {
            ToastUtils.showShort(Rstring.use_horizontal_or_use_vertical_must_check_at_least_one());
            return false;
        }
        boolean check_empty_b, check_empty_l, check_empty_h, check_empty_x, check_empty_y, check_empty_z;
        String b_text = met_b.getText().toString().trim();
        String l_text = met_l.getText().toString().trim();
        String h_text = met_h.getText().toString().trim();
        String x_text = met_x.getText().toString().trim();
        String y_text = met_y.getText().toString().trim();
        String z_text = met_z.getText().toString().trim();

        check_empty_b = !"".equals(b_text) && !"-".equals(b_text) && !"+".equals(b_text) && !".".equals(b_text) && !"-.".equals(b_text) && !"+.".equals(b_text);
        if (check_empty_b) {
            try {
                double b = Math.toDegrees(Util.dmsStringToRadian(met_b.getText().toString(), false));
                if (b < -90 || b > 90) {
                    met_b.setError(getString(Rstring.latitude_invalid()));
                    check_empty_b = false;
                } else {
                    met_b.setError(null);
                    check_empty_b = true;
                }
            } catch (NumberFormatException ex) {
                check_empty_b = false;
                met_b.setError(getString(Rstring.latitude_invalid()));
            }
        } else {
            met_b.setError(getString(Rstring.illegal_value()));
        }
        check_empty_l = !"".equals(l_text) && !"-".equals(l_text) && !"+".equals(l_text) && !".".equals(l_text) && !"-.".equals(l_text) && !"+.".equals(l_text);
        if (check_empty_l) {
            try {
                double l = Math.toDegrees(Util.dmsStringToRadian(met_l.getText().toString(), false));
                if (l < -180 || l > 180) {
                    met_l.setError(getString(Rstring.longitude_invalid()));
                    check_empty_l = false;
                } else {
                    met_l.setError(null);
                    check_empty_l = true;
                }
            } catch (NumberFormatException ex) {
                met_l.setError(getString(Rstring.longitude_invalid()));
                check_empty_l = false;
            }
        } else {
            met_l.setError(getString(Rstring.illegal_value()));
        }

        check_empty_h = !"".equals(h_text) && !"-".equals(h_text) && !"+".equals(h_text) && !".".equals(h_text) && !"-.".equals(h_text) && !"+.".equals(h_text);
        if (check_empty_h) {
            met_h.setError(null);
        } else {
            met_h.setError(getString(Rstring.illegal_value()));
        }
        check_empty_x = !"".equals(x_text) && !"-".equals(x_text) && !"+".equals(x_text) && !".".equals(x_text) && !"-.".equals(x_text) && !"+.".equals(x_text);
        if (check_empty_x) {
            met_x.setError(null);
        } else {
            met_x.setError(getString(Rstring.input_illegal()));
        }
        check_empty_y = !"".equals(y_text) && !"-".equals(y_text) && !"+".equals(y_text) && !".".equals(y_text) && !"-.".equals(y_text) && !"+.".equals(y_text);
        if (check_empty_y) {
            met_y.setError(null);
        } else {
            met_y.setError(getString(Rstring.input_illegal()));
        }
        check_empty_z = !"".equals(z_text) && !"-".equals(z_text) && !"+".equals(z_text) && !".".equals(z_text) && !"-.".equals(z_text) && !"+.".equals(z_text);
        if (check_empty_z) {
            met_z.setError(null);
        } else {
            met_z.setError(getString(Rstring.input_illegal()));
        }

        return check_empty_b && check_empty_l && check_empty_h && check_empty_x && check_empty_y && check_empty_z;
    }

    private void initMaterialEditTextColor() {
        if (/*((App) Utils.getApp()).*/isThemeDark()) {
            met_b.setMetTextColor(Color.WHITE);
            met_l.setMetTextColor(Color.WHITE);
            met_h.setMetTextColor(Color.WHITE);
            met_name.setMetTextColor(Color.WHITE);
            met_x.setMetTextColor(Color.WHITE);
            met_y.setMetTextColor(Color.WHITE);
            met_z.setMetTextColor(Color.WHITE);

            met_b.setPrimaryColor(Color.LTGRAY);
            met_l.setPrimaryColor(Color.LTGRAY);
            met_h.setPrimaryColor(Color.LTGRAY);
            met_name.setPrimaryColor(Color.LTGRAY);
            met_x.setPrimaryColor(Color.LTGRAY);
            met_y.setPrimaryColor(Color.LTGRAY);
            met_z.setPrimaryColor(Color.LTGRAY);

            met_b.setFocusFraction(1.0f);
            met_l.setFocusFraction(1.0f);
            met_h.setFocusFraction(1.0f);
            met_name.setFocusFraction(1.0f);
            met_x.setFocusFraction(1.0f);
            met_y.setFocusFraction(1.0f);
            met_z.setFocusFraction(1.0f);

            met_b.setMetHintTextColor(Color.GRAY);
            met_l.setMetHintTextColor(Color.GRAY);
            met_h.setMetHintTextColor(Color.GRAY);
            met_name.setMetHintTextColor(Color.GRAY);
            met_x.setMetHintTextColor(Color.GRAY);
            met_y.setMetHintTextColor(Color.GRAY);
            met_z.setMetHintTextColor(Color.GRAY);

            met_b.setUnderlineColor(Color.GRAY);
            met_l.setUnderlineColor(Color.GRAY);
            met_h.setUnderlineColor(Color.GRAY);
            met_name.setUnderlineColor(Color.GRAY);
            met_x.setUnderlineColor(Color.GRAY);
            met_y.setUnderlineColor(Color.GRAY);
            met_z.setUnderlineColor(Color.GRAY);
        }
    }

    /**
     * 处理仪器传回的数据
     */
    public void dealReceivedBLH(Blh blh) {
        if (mTimes >= 0 && mTimes < 10) {
            mSumB += blh.getLatitude();
            mSumL += blh.getLongitude();
            mSumH += blh.getAltitude();
            mTimes++;
            progressBar.setProgress(mTimes);
            if (mTimes == 10) {
                b = mSumB / mTimes;
                l = mSumL / mTimes;
                h = mSumH / mTimes;
                met_b.setText(Util.radianToDmsDoubleString(Math.toRadians(b), 6, false));
                met_l.setText(Util.radianToDmsDoubleString(Math.toRadians(l), 6, false));
                met_h.setText(Util.formatDouble2StringDotAuto(h));
            }
        }
    }

    @Override
    public void updateRtkPosition(boolean isTiltValid, Blh blh, Blh originalBlh, Coordinate coordinate) {
        if (Device.getInstance().isRtkRunning) {
            dealReceivedBLH(blh);
        }
    }


    ///////////////////////
    protected abstract void selectBLH();

    protected abstract void selectXYZ();

    protected abstract boolean isThemeDark();

    @WorkerThread
    protected abstract void save(CoordinateSystem coordinateSystem);

    protected abstract void loadCurrentCoordinateSystem(IOnSingleGetCallback<CoordinateSystem> callback);
}
