package com.project.survey.ui.instrument.mobilestationmode.base;

import com.bingce.coordlib.model.Blh;
import com.bingce.coordlib.model.Coordinate;
import com.bingce.coordlib.model.CoordinateSystem;
import com.bingce.data.cache.CachedCurrentCoordinateSystem;
import com.bingce.device.ui.dialog.DialogUtil;
import com.bingce.device.ui.rtk.RtkBaseSettingFragment;
import com.bingce.rtk.util.CoordTransUtil;
import com.bingce.utils.ThreadPoolUtil;
import com.project.survey.R;
import com.project.survey.ui.instrument.setupstation.ControlPointsNewActivity;
import com.project.survey.ui.instrument.setupstation.CoordinatePointsLibraryActivity;
import com.project.survey.ui.instrument.setupstation.StakingNewJobActivity;
import com.project.survey.util.CommonUtils;

public class RtkBaseSettingActivity extends AbstractRtkBaseSettingActivity {
    @Override
    protected void setBasePositionClickListener(RtkBaseSettingFragment fragment) {
        fragment.setBasePositionClickListener(coordinateType -> {
            CommonUtils.hideSoftInput();
            String[] arr = new String[]{RtkBaseSettingActivity.this.getString(R.string.road_control_point), RtkBaseSettingActivity.this.getString(R.string.global_control_point), RtkBaseSettingActivity.this.getString(R.string.point_survey_point_library), RtkBaseSettingActivity.this.getString(R.string.staking_point_library)};
            ThreadPoolUtil.execute(new Runnable() {
                @Override
                public void run() {
                    CoordinateSystem coordinateSystem = CachedCurrentCoordinateSystem.currentCoordinateSystem();
                    runOnUiThread(new Runnable() {
                        @Override
                        public void run() {
                            DialogUtil.mMaterialItemsDialog(RtkBaseSettingActivity.this, R.string.data_source, arr, (dialog, itemView, position, text) -> {
                                switch (position) {
                                    case 0:
                                        ControlPointsNewActivity.pickPoint(RtkBaseSettingActivity.this, false, (name, code, x, y, z, lat, lon, alt, remarks) -> {
                                            switch (coordinateType) {
                                                case GEODETIC:
                                                    fragment.setBasePositionBlh(new Blh(lat, lon, alt));
                                                    break;
                                                case PROJECTION:
                                                    fragment.setBasePositionCoordinate(new Coordinate(x, y, z));
                                                    break;
                                            }
                                        });
                                        break;
                                    case 1:
                                        ControlPointsNewActivity.pickPoint(RtkBaseSettingActivity.this, true, (name, code, x, y, z, lat, lon, alt, remarks) -> {
                                            switch (coordinateType) {
                                                case GEODETIC:
                                                    fragment.setBasePositionBlh(new Blh(lat, lon, alt));
                                                    break;
                                                case PROJECTION:
                                                    fragment.setBasePositionCoordinate(new Coordinate(x, y, z));
                                                    break;
                                            }
                                        });
                                        break;
                                    case 2:
                                        CoordinatePointsLibraryActivity.pickPoint(RtkBaseSettingActivity.this, (name, code, x, y, z, b, l, h) -> {
                                            switch (coordinateType) {
                                                case GEODETIC:
                                                    fragment.setBasePositionBlh(new Blh(b, l, h));
                                                    break;
                                                case PROJECTION:
                                                    fragment.setBasePositionCoordinate(new Coordinate(x, y, z));
                                                    break;
                                            }
                                        });
                                        break;
                                    case 3:
                                        StakingNewJobActivity.pickPoint(RtkBaseSettingActivity.this, (name, x, y, z) -> {
                                            switch (coordinateType) {
                                                case GEODETIC:
                                                    Blh blh = CoordTransUtil.xyz2Wgs84Blh(x, y, z, coordinateSystem);
                                                    fragment.setBasePositionBlh(blh == null ? new Blh() : blh);
                                                    break;
                                                case PROJECTION:
                                                    fragment.setBasePositionCoordinate(new Coordinate(x, y, z));
                                                    break;
                                            }
                                        });
                                        break;
                                }
                            });
                        }
                    });
                }
            });
        });
    }
}