package com.project.survey.ui.instrument.mobilestationmode.rover;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;

import androidx.annotation.Keep;
import androidx.appcompat.widget.Toolbar;
import androidx.fragment.app.Fragment;

import com.bingce.device.ui.rtk.RtkRoverSettingFragment;
import com.bingce.device.ui.utils.DeviceUtil;
import com.bingce.rtk.command.RTK;
import com.bingce.rtk.command.qxwz.QxwzRTK;
import com.huawei.hms.hmsscankit.ScanUtil;
import com.huawei.hms.ml.scan.HmsScan;
import com.project.survey.R;

import org.polaric.colorful.ColorfulActivity;


@Keep
public class RtkRoverSettingActivity extends ColorfulActivity {
    protected Button btn_save_apply, btn_save;

    public void initUiSetting(Fragment fragment) {

    }

    @SuppressLint("SourceLockedOrientationActivity")
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_rtk_rover_setting);
        Toolbar mToolbar = findViewById(R.id.toolbar);
        setSupportActionBar(mToolbar);
        if (getSupportActionBar() != null)
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        RtkRoverSettingFragment fragment = new RtkRoverSettingFragment();
        initUiSetting(fragment);

        getSupportFragmentManager()
                .beginTransaction()
                .add(R.id.activity_rtk_rover_setting_fragment, fragment)
                .commit();

        btn_save = findViewById(R.id.activity_rover_setting_btn_save);
        btn_save_apply = findViewById(R.id.activity_rover_setting_btn_save_apply);

        btn_save.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                RtkRoverSettingFragment fragment = getRoverFragment();
                if (fragment != null) {
                    if (fragment.saveSettings()) {
                        finish();
                    }
                }
            }
        });

        btn_save_apply.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                RtkRoverSettingFragment fragment = getRoverFragment();
                if (fragment != null) {
                    if (fragment.saveSettings()) {
                        fragment.apply();
                        if (RTK.getInstance() instanceof QxwzRTK) {//千寻没有进度条，所以直接返回上一界面
                            finish();
                        }
                    }
                }
            }
        });
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode != RESULT_OK || data == null) {
            return;
        }
        if (requestCode == RtkRoverSettingFragment.REQUEST_CODE_SCAN_ONE) {
            HmsScan obj = data.getParcelableExtra(ScanUtil.RESULT);
            String result = obj.getOriginalValue();
            RtkRoverSettingFragment fragment = getRoverFragment();
            if (fragment != null) {
                fragment.scanResult(result);
            }
        }
    }

    public RtkRoverSettingFragment getRoverFragment() {
        Fragment fragment = DeviceUtil.getCurrentFragment(this, R.id.activity_rtk_rover_setting_fragment);
        if (fragment instanceof RtkRoverSettingFragment) {
            return (RtkRoverSettingFragment) fragment;
        }
        return null;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int itemId = item.getItemId();
        if (itemId == android.R.id.home) {
            finish();
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case KeyEvent.KEYCODE_BACK:
                finish();
                break;
        }
        return true;
    }
}