package com.project.survey.ui.instrument.mobilestationmode.staticc;

import android.annotation.SuppressLint;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;

import androidx.annotation.Keep;
import androidx.appcompat.widget.Toolbar;
import androidx.fragment.app.Fragment;

import com.bingce.device.ui.rtk.RtkStaticSettingFragment;
import com.bingce.device.ui.utils.DeviceUtil;
import com.project.survey.R;

import org.polaric.colorful.ColorfulActivity;

@Keep
public class RtkStaticSettingActivity extends ColorfulActivity {
    protected Button btn_apply, btn_save;

    public void initUiSetting(Fragment fragment) {

    }

    @SuppressLint("SourceLockedOrientationActivity")
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_rtk_static_setting);
        Toolbar mToolbar = findViewById( R.id.toolbar);
        setSupportActionBar(mToolbar);
        if (getSupportActionBar() != null)
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        RtkStaticSettingFragment fragment = new RtkStaticSettingFragment();
        initUiSetting(fragment);

        getSupportFragmentManager()
                .beginTransaction()
                .add( R.id.activity_rtk_static_setting_fragment, fragment)
                .commit();

        btn_save = findViewById(R.id.activity_static_setting_btn_save);
        btn_apply = findViewById(R.id.activity_static_setting_btn_save_apply);
        btn_save.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                RtkStaticSettingFragment fragment = getStaticFragment();
                if (fragment != null) {
                    if (fragment.saveSettings()) {
                        finish();
                    }
                }
            }
        });
        btn_apply.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                RtkStaticSettingFragment fragment = getStaticFragment();
                if (fragment != null) {
                    if (fragment.saveSettings()) {
                        fragment.apply();
                    }
                }
            }
        });
    }

    public RtkStaticSettingFragment getStaticFragment() {
        Fragment fragment = DeviceUtil.getCurrentFragment(this, R.id.activity_rtk_static_setting_fragment);
        if (fragment instanceof RtkStaticSettingFragment) {
            return (RtkStaticSettingFragment) fragment;
        }
        return null;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int itemId = item.getItemId();
        if (itemId == android.R.id.home) {
            finish();
        }
        return super.onOptionsItemSelected(item);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        switch (keyCode) {
            case KeyEvent.KEYCODE_BACK:
                finish();
                break;
        }
        return true;
    }
}