package com.project.survey.ui.instrument.satellitosis;

import android.os.Bundle;
import android.view.MenuItem;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.bingce.device.Device;
import com.bingce.rtk.command.RtkCommand;
import com.bingce.rtk.gnss.Gnss;
import com.project.survey.R;
import com.project.survey.databinding.ActivitySatelliteSystemSwitchBinding;

import org.polaric.colorful.ColorfulActivity;

public class SatelliteSystemSwitchActivity extends ColorfulActivity {

    private ActivitySatelliteSystemSwitchBinding binding;

    @Override
    protected void onCreate(@Nullable Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        binding = ActivitySatelliteSystemSwitchBinding.inflate(getLayoutInflater());
        setContentView(binding.getRoot());
        setSupportActionBar(binding.getRoot().findViewById(R.id.toolbar));
        if (getSupportActionBar() != null)
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);

        binding.switchGps.setChecked(Gnss.getInstance().getGps().isGpsEnable());
        binding.switchGlonass.setChecked(Gnss.getInstance().getGps().isGlonassEnable());
        binding.switchBeidou.setChecked(Gnss.getInstance().getGps().isBeidouEnable());
        binding.switchGalileo.setChecked(Gnss.getInstance().getGps().isGalileoEnable());
        binding.switchQzss.setChecked(Gnss.getInstance().getGps().isQzssEnable());
        binding.switchSbas.setChecked(Gnss.getInstance().getGps().isSbasEnable());
        binding.btnApply.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                Device.getInstance().rtkSendCommand(RtkCommand.getInstance().setSatelliteSystem(true));
            }
        });
    }

    @Override
    public boolean onOptionsItemSelected(@NonNull MenuItem item) {
        switch (item.getItemId()) {
            case android.R.id.home:
                finish();
                break;
        }
        return super.onOptionsItemSelected(item);
    }
}
