package com.project.survey.ui.instrument.setupstation;

import android.content.Intent;

import androidx.fragment.app.Fragment;

import com.afollestad.materialdialogs.MaterialDialog;
import com.bingce.device.Device;
import com.bingce.device.enums.DeviceTypeEnum;
import com.bingce.totalstation.TsConfig;
import com.bingce.totalstation.enums.SetupStationMethodEnum;
import com.project.survey.R;

import blankj.utilcode.util.ToastUtils;
import blankj.utilcode.util.Utils;


public class InstrumentSetFragmentSetupStationTypeUtils {
    /**
     * 选择设站模式
     */
    public static void chooseSetupStationType(Fragment fragment) {
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_RTK) {
            ToastUtils.showShort("当前仪器模式不支持");
            return;
        }
        new MaterialDialog.Builder(fragment.getActivity())
                .items(R.array.setup_station_type_with_current)
                .itemsCallback((dialog, view, which, text) -> {
                    switch (which) {
                        case 0:
                            fragment.startActivity(new Intent(Utils.getApp(), SetupStationCurrentActivity.class));
                            break;
                        case 1:
                            TsConfig.getInstance().setSetupStationMethod(SetupStationMethodEnum.TS_DONE_SKIP);
                            ToastUtils.showShort(R.string.apply_success);
                            break;
                        case 2:
                            TsConfig.getInstance().setSetupStationMethod(SetupStationMethodEnum.TS_DONE_INPUT_INTO_APP);
                            fragment.startActivity(new Intent(Utils.getApp(), SetupStationInputActivity.class));
                            break;
                        case 3:
                            TsConfig.getInstance().setSetupStationMethod(SetupStationMethodEnum.APP_SETUP_KNOWN_BACK_SIGHT);
                            fragment.startActivity(new Intent(Utils.getApp(), SetupStationKnownBackSightActivity.class));
                            break;
                        case 4:
                            TsConfig.getInstance().setSetupStationMethod(SetupStationMethodEnum.APP_SETUP_RESECTION);
                            fragment.startActivity(new Intent(Utils.getApp(), SetupStationResectionActivity.class));
                    }
                    TsConfig.getInstance().save();
//                    ((App) Utils.getApp()).lastTsSetupStationType = which - 1;
//                    Util.putPreference("lastTsSetupStationType", ((App) Utils.getApp()).lastTsSetupStationType);
                }).show();
    }
}
