package com.project.survey.ui.instrument.setupstation

import android.os.Bundle
import androidx.recyclerview.widget.DiffUtil
import com.bingce.data.surveyor.surveydata.pointsurvey.PointRecord
import com.bingce.utils.DateUtils
import com.bingce.utils.Util

class PointRecordDiffCallback2: DiffUtil.ItemCallback<PointRecord>() {

    override fun areItemsTheSame(oldItem: PointRecord, newItem: PointRecord): Boolean {
        return oldItem.id == newItem.id
    }

    override fun areContentsTheSame(oldItem: PointRecord, newItem: PointRecord): Boolean {
        return oldItem == newItem
    }

    override fun getChangePayload(oldItem: PointRecord, newItem: PointRecord): Any? {
        val bundle = Bundle()

        if (oldItem.name != newItem.name){
            bundle.putString("name",newItem.name)
        }
        if (oldItem.code != newItem.code){
            bundle.putString("code",newItem.code)
        }
        if (oldItem.x != newItem.x){
            bundle.putString("x", Util.formatDouble2StringDotAuto(newItem.x))
        }
        if (oldItem.y != newItem.y){
            bundle.putString("y", Util.formatDouble2StringDotAuto(newItem.y))
        }
        if (oldItem.h != newItem.h){
            bundle.putString("h", Util.formatDouble2StringDotAuto(newItem.h))
        }
        if (oldItem.createDate.time != newItem.createDate.time){
            bundle.putString("time", DateUtils.toFull(newItem.createDate))
        }
        if (bundle.size() == 0) return null
        return bundle
    }
}