package com.project.survey.ui.instrument.setupstation;

import com.afollestad.materialdialogs.MaterialDialog;
import com.bingce.device.ui.totalstation.AbstractSetupStationInputActivity;
import com.project.survey.App;
import com.project.survey.R;

import blankj.utilcode.util.Utils;

public class SetupStationInputActivity extends AbstractSetupStationInputActivity {
    @Override
    protected void selectPoint() {
        String[] titles = new String[]{
                getString(R.string.point_survey_point_library),
                getString(R.string.staking_point_library)};
        new MaterialDialog.Builder(this)
                .title(R.string.data_source)
                .items(titles)
                .itemsCallback((dialog, itemView, which, text) -> {
                    switch (which) {
                        case 0:
                            CoordinatePointsLibraryActivity.pickPoint(this, (name, code, x, y, z, b, l, h) -> {
                                onPicked(name, x, y, z);
                            });
                            break;
                        case 1:
                            StakingNewJobActivity.pickPoint(this, (name, x, y, z) -> {
                                onPicked(name, x, y, z);
                            });
                            break;
                    }
                }).show();
    }


    @Override
    protected boolean isThemeDark() {
        return App.instance.isThemeDark();
    }

    @Override
    protected void hideSoftKey() {
        BingCeBaseSurveyPresenter.hideSoftKey();
    }

    @Override
    protected void speak(String string) {
        BingCeBaseSurveyPresenter.speak(string);
    }

    @Override
    protected void updateLastRTKLocation() {
        BingCeBaseSurveyPresenter.updateLastRTKLocation();
    }

    @Override
    protected boolean checkRegister() {
        return BingCeBaseSurveyPresenter.checkRegister();
    }

    @Override
    protected int volumeUpAction() {
        return BingCeBaseSurveyPresenter.volumeUpAction();
    }

    @Override
    protected int volumeDownAction() {
        return BingCeBaseSurveyPresenter.volumeDownAction();
    }

}