package com.project.survey.ui.instrument.setupstation.db;

import androidx.annotation.NonNull;
import androidx.room.ColumnInfo;
import androidx.room.PrimaryKey;

import com.bingce.data.surveyor.surveydata.pointsurvey.PointRecord;

import java.util.Date;

public class PointSurveyRecord {
    @PrimaryKey
    @NonNull
    @ColumnInfo(name = "pointId")
    public String pointId;

    @ColumnInfo(name = "workId")
    public String workId;

    @ColumnInfo(name = "pointType")
    public int pointType;

    @ColumnInfo(name = "pointName")
    public String pointName;

    @ColumnInfo(name = "format")//坐标格式
    public int format;

    @ColumnInfo(name = "latitude")
    public double latitude;

    @ColumnInfo(name = "longitude")
    public double longitude;

    @ColumnInfo(name = "altitude")
    public double altitude;

    @ColumnInfo(name = "originalLatitude")
    public double originalLatitude;

    @ColumnInfo(name = "originalLongitude")
    public double originalLongitude;

    @ColumnInfo(name = "originalAltitude")
    public double originalAltitude;

    @ColumnInfo(name = "planeN")
    public double planeN;

    @ColumnInfo(name = "planeE")
    public double planeE;

    @ColumnInfo(name = "planeH")
    public double planeH;

    @ColumnInfo(name = "code")//编码
    public String code;

    @ColumnInfo(name = "remarks")//备注
    public String remarks;

    @ColumnInfo(name = "createdAt")//创建或保存时间
    public Date createdAt;

    @ColumnInfo(name = "timeStamp")//时间戳（创建或保存时间）
    public long timeStamp;

    @ColumnInfo(name = "projectId")
    public String projectId;

    @ColumnInfo(name = "hr")//棱镜高
    public double hr;

    @ColumnInfo(name = "electricity")//仪器电量
    public int electricity;

    @ColumnInfo(name = "pdop")
    public double pdop;

    @ColumnInfo(name = "hrms")
    public double hrms;

    @ColumnInfo(name = "vrms")
    public double vrms;

    @ColumnInfo(name = "posType")//解状态 id（仪器返回的id）
    public int posType;

    @ColumnInfo(name = "diffAge")//延迟（差分延时）
    public double diffAge;

    @ColumnInfo(name = "sysMode")//系统模式
    public String sysMode;

    @ColumnInfo(name = "isSelect")//是否可选（非必传）
    public boolean isSelect;

    @ColumnInfo(name = "antennaHeight")//天线高度
    public double antennaHeight;

    @ColumnInfo(name = "antennaType")//天线类型id
    public int antennaType;

    @ColumnInfo(name = "antennaTypeName")//天线类型name
    public String antennaTypeName;

    @ColumnInfo(name = "solutionState")//解状态 name(名称)
    public String solutionState;

    @ColumnInfo(name = "satelliteNum")//解算卫星数量
    public int satelliteNum;

    @ColumnInfo(name = "satelliteTrackNum")//可见卫星数量
    public int satelliteTrackNum;

    @ColumnInfo(name = "siteId")//基站id
    public String siteId;

    @ColumnInfo(name = "siteLatitude")//基站纬度
    public double siteLatitude;

    @ColumnInfo(name = "siteLongitude")//基站经度
    public double siteLongitude;

    @ColumnInfo(name = "siteDistance2D")//基站距离（平面）
    public double siteDistance2D;

    @ColumnInfo(name = "isTiltEnable")//惯导是否可用
    public boolean isTiltEnable;

    public final PointRecord record;

    public PointSurveyRecord(PointRecord record) {
        this.record = record;
    }

    public static PointSurveyRecord convert(PointRecord pointRecord){
        PointSurveyRecord pointSurveyRecord = new PointSurveyRecord(pointRecord);
        pointSurveyRecord.pointId = pointRecord.id;
        pointSurveyRecord.pointName = pointRecord.name;
        pointSurveyRecord.code = pointRecord.code;
        pointSurveyRecord.remarks = pointRecord.remarks;
        pointSurveyRecord.planeN = pointRecord.x;
        pointSurveyRecord.planeE = pointRecord.y;
        pointSurveyRecord.planeH = pointRecord.h;
        pointSurveyRecord.latitude = pointRecord.latitude;
        pointSurveyRecord.longitude = pointRecord.longitude;
        pointSurveyRecord.altitude = pointRecord.altitude;
        pointSurveyRecord.originalLatitude = pointRecord.originalLatitude;
        pointSurveyRecord.originalLongitude = pointRecord.originalLongitude;
        pointSurveyRecord.originalAltitude = pointRecord.originalAltitude;
        pointSurveyRecord.createdAt = pointRecord.createDate;
        return pointSurveyRecord;
    }
}
