package com.project.survey.ui.instrument.setupstation.db;

import android.content.Context;

import androidx.room.Database;
import androidx.room.Room;
import androidx.room.RoomDatabase;


import com.bingce.path.PathManager;
import com.project.survey.ui.instrument.setupstation.db.resultformat.FormatRecord;
import com.project.survey.ui.instrument.setupstation.db.resultformat.FormatRecordDao;

import blankj.utilcode.util.Utils;

@Database(entities = {
        FormatRecord.class
}, version = 1)

public abstract class RecordsFixedDataBase extends RoomDatabase {
    public static final String DB_NAME = "records_fixed.db";
    public abstract FormatRecordDao formatRecordDao();

    private static RecordsFixedDataBase instance = null;

    public static void reset() {
        synchronized (RecordsFixedDataBase.class) {
            Context applicationContext = Utils.getApp().getApplicationContext();
            //2.创建数据实例
            instance = readInstance(applicationContext);
        }
    }

    public static RecordsFixedDataBase readInstance(Context context) {
        return Room.databaseBuilder(
                        context.getApplicationContext(),
                        RecordsFixedDataBase.class,
                        PathManager.defaultDbPath(context, DB_NAME))
                .enableMultiInstanceInvalidation()
                .fallbackToDestructiveMigrationOnDowngrade()
                .build();
    }

    public static RecordsFixedDataBase getInstance() {
        if (instance == null) {
            reset();
        }
        return instance;
    }
}
