package com.project.survey.ui.instrument.setupstation.db.controlpoint;

public class Constants {
    public static final String DB_NAME_CONFIG = "__configs__";
    public static final String DB_NAME_USER = "__users__";
    public static final String DB_NAME_PROJECT = "__projects__";
    public static final String DB_NAME_PROJECT2 = "__projects_2_";
    public static final String DB_NAME_PART = "__parts__";
    public static final String DB_NAME_POINT = "__points__";
    public static final String DB_NAME_CONTROL_POINT = "__control_points__";
    public static final String DB_NAME_STAKE_RECORD = "__stake_records__";

    public static final String DB_SQL_SELECT_CONFIG_ALL = "SELECT * FROM " + DB_NAME_CONFIG;
    public static final String DB_SQL_SELECT_CONFIG_BY_ID = "SELECT * FROM " + DB_NAME_CONFIG + " WHERE id =:id";
    public static final String DB_SQL_COUNT_OF_CONFIG = "SELECT count(*) FROM " + DB_NAME_CONFIG;

    public static final String DB_SQL_SELECT_PROJECT_ALL = "SELECT * FROM " + DB_NAME_PROJECT2;
    public static final String DB_SQL_DELETE_PROJECT_ALL = "DELETE FROM " + DB_NAME_PROJECT2;
    public static final String DB_SQL_SELECT_PROJECT_BY_ID = "SELECT * FROM " + DB_NAME_PROJECT2 + " WHERE id =:id";

    public static final String DB_SQL_SELECT_RECORD_ALL = "SELECT * FROM " + DB_NAME_STAKE_RECORD;
    public static final String DB_SQL_SELECT_RECORD_BY_ID =
            "SELECT * FROM " + DB_NAME_STAKE_RECORD + " WHERE id =:id";
    public static final String DB_SQL_DELETE_RECORD_BY_ID =
            "DELETE FROM " + DB_NAME_STAKE_RECORD + " WHERE id =:id";
    public static final String DB_SQL_SELECT_RECORD_BY_POSITION_ID =
            "SELECT * FROM " + DB_NAME_STAKE_RECORD + " WHERE position_id =:id";

    public static final String DB_SQL_SELECT_PART_ALL = "SELECT * FROM " + DB_NAME_PART;
    public static final String DB_SQL_SELECT_PART_BY_ID = "SELECT * FROM " + DB_NAME_PART + " WHERE id =:id";
    public static final String DB_SQL_SELECT_PART_BY_PROJECT_ID =
            "SELECT * FROM " + DB_NAME_PART + " WHERE project_id =:id and parent_id=\"-1\"";
    public static final String DB_SQL_SELECT_PART_BY_PARENT_ID =
            "SELECT * FROM " + DB_NAME_PART + " WHERE parent_id =:id";

    public static final String DB_SQL_SELECT_CONTROL_POINTS_ALL =
            "SELECT * FROM " + DB_NAME_CONTROL_POINT;
    public static final String DB_SQL_SELECT_CONTROL_POINT_BY_ID =
            "SELECT * FROM " + DB_NAME_CONTROL_POINT + " WHERE id =:id";
    public static final String DB_SQL_SELECT_CONTROL_POINTS_BY_PROJECT_ID =
            "SELECT * FROM " + DB_NAME_CONTROL_POINT + " WHERE project_id =:id";

    public static final String DB_SQL_SELECT_POINT_ALL = "SELECT * FROM " + DB_NAME_POINT;
    public static final String DB_SQL_SELECT_POINT_BY_ID = "SELECT * FROM " + DB_NAME_POINT + " WHERE id =:id";
    public static final String DB_SQL_SELECT_POINT_BY_PART_ID = "SELECT * FROM " + DB_NAME_POINT + " WHERE position_id =:id order by point_name asc";
    public static final String DB_SQL_SELECT_POINT_BY_PROJECT_ID = "SELECT * FROM " + DB_NAME_POINT + " WHERE project_id =:id order by point_name asc";
    public static final String DB_SQL_DELETE_POINT_BY_PROJECT_POSITION = "DELETE FROM " + DB_NAME_POINT + " WHERE ( project_id =:projectId ) AND ( position_id =:positionId)";
    public static final String DB_SQL_DELETE_POINT_BY_PROJECT = "DELETE FROM " + DB_NAME_POINT + " WHERE ( project_id =:projectId ) ";

    public static final String DB_CONFIG_KEY_USER_NAME = "__user_name_new";
    public static final String DB_CONFIG_KEY_PWD = "__password_new";
    public static final String DB_CONFIG_KEY_COOKIE = "__cookie";
    public static final String DB_CONFIG_KEY_LAST_PROJECT = "__last_project__";
    public static final String DB_CONFIG_KEY_LAST_LOGIN = "__last_login__";

    public static final String API_RET_FLAG = "rtnFlag";
    public static final String API_RET_MSG = "rtnMessage";
    public static final String API_RET_OBJ = "rtnObj";
    public static final String API_RET_FLAG_IS_SUCCESS = "isSuccess";
    public static final String API_RET_MSG_2 = "rtnMsg";


    public static final int MEASURE_TYPE_WORK = 1;
    public static final int MEASURE_TYPE_CHECK = 3;
}
