package com.project.survey.ui.instrument.setupstation.db.controlpoint;

import androidx.lifecycle.LiveData;
import androidx.room.Dao;
import androidx.room.Delete;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;

import java.util.List;

@Dao
public interface ControlPointDao {
    @Query(Constants.DB_SQL_SELECT_CONTROL_POINTS_ALL)
    LiveData<List<ControlPointItem>> getAll();

    @Query(Constants.DB_SQL_SELECT_CONTROL_POINT_BY_ID)
    LiveData<ControlPointItem> find(String id);

    @Query(Constants.DB_SQL_SELECT_CONTROL_POINTS_BY_PROJECT_ID)
    LiveData<List<ControlPointItem>> findByProjectId(String id);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void insertAll(ControlPointItem... tubes);

    @Delete
    void delete(ControlPointItem tube);
}