package com.project.survey.ui.instrument.setupstation.db.resultformat;

import androidx.room.Dao;
import androidx.room.Insert;
import androidx.room.OnConflictStrategy;
import androidx.room.Query;

import java.util.List;

@Dao
public interface FormatRecordDao {

    @Query("SELECT * FROM " + FormatConstants.DB_NAME)
    List<FormatRecord> findAll();

    @Query("SELECT * FROM " + FormatConstants.DB_NAME + " ORDER BY id DESC")
    List<FormatRecord> findDescAll();

    @Query("SELECT * FROM " + FormatConstants.DB_NAME + " WHERE id=:id")
    FormatRecord findById(String id);

    @Query("DELETE FROM " + FormatConstants.DB_NAME + " WHERE id=:id")
    void deleteById(String id);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void save(FormatRecord record);
}
