package com.project.survey.ui.instrument.setupstation.util;

import android.content.Context;

import androidx.annotation.WorkerThread;

import com.bingce.TimeCount;
import com.bingce.data.database.KeyValueDb;
import com.bingce.data.surveyor.designdata.kv.KeyValueRecord;
import com.bingce.road.xport.RoadAllUtil;

import java.io.File;

public class CollectAndroidDataFolderUtils {

    @WorkerThread
    public static boolean collectFromDataFolder(Context appCompatActivity, File dataFolder, CollectLocalDataInAppStartFirstTimeUtil.ILog log, TimeCount.ITimeCounter timeCounter) {
        log.log("检测Data目录下数据");
        if (!dataFolder.exists()) {
            log.log("Data目录不存在");
            return false;
        }
        File[] children = dataFolder.listFiles();
        if (children == null || children.length == 0) {
            log.log("Data目录为空.");
            return false;
        }
        //检测是否有road目录
        boolean hasRoad = false;
        for (File folder : children) {
            if (RoadAllUtil.isRoadFolder(folder)) {
                hasRoad = true;
                break;
            }
        }
        if (!hasRoad) {
            log.log("Data目录为空..");
            return false;
        }
        File mark = new File(dataFolder, CollectLocalDataInAppStartFirstTimeUtil.COLLECTED_FILE_NAME);
        if (mark.exists()) {//已经收集过了
            log.log("Data目录数据已收集");
            return true;
        }
        //1.收集全站仪数据
        _1TotalStationCollectUtils.collect(dataFolder, log);
        //遍历目录
        File[] projects = dataFolder.listFiles();
        if (projects == null) {
            log.log("项目数据为空");
            return false;
        }
        //2.遍历项目目录
        for (File project : projects) {
            if (!project.exists() || project.isFile()) {
                continue;
            }
            ProjectDbUtils.collect(appCompatActivity, project, log, timeCounter);
        }
        //生成收集标识
        if (!CollectLocalDataInAppStartFirstTimeUtil.generatorCollectedFile(dataFolder)) {
            KeyValueDb.getInstance().save(new KeyValueRecord());
        }

        return true;
    }
}
