package com.project.survey.ui.instrument.setupstation.util;

import android.content.Context;
import android.content.DialogInterface;
import android.os.CountDownTimer;

import androidx.annotation.StringRes;

import com.afollestad.materialdialogs.DialogAction;
import com.afollestad.materialdialogs.MaterialDialog;
import com.afollestad.materialdialogs.internal.MDButton;
import com.project.survey.R;


public class ControlPointsClearDialogUtils {
    private final Context context;

    private MDButton mPositiveAction;

    public ControlPointsClearDialogUtils(Context context) {
        this.context = context;
    }


    public void showClearDialog(ICallback callback) {
        MaterialDialog dialog = new MaterialDialog.Builder(context)
                .title(R.string.warning)
                .content(R.string.confirm_clear_points)
                .positiveText(getString(R.string.clear))
                .negativeText(getString(R.string.cancel))
                .onPositive((dialog1, which) -> {
//                        isPrjChanged = true;
//                        allControlPoints.clear();
//                        updateRecyclerView();
//                        ToastUtils.showShort(R.string.clean_over);
                    callback.onCleared();
                })
                .build();

        mPositiveAction = dialog.getActionButton(DialogAction.POSITIVE);
        mPositiveAction.setEnabled(false);
        final CountDownTimer countDownTimer = new CountDownTimer(5000, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
                mPositiveAction.setText(getString(R.string.clear) + "(" + millisUntilFinished / 1000 + "s)");
            }

            @Override
            public void onFinish() {
                mPositiveAction.setEnabled(true);
                mPositiveAction.setText(R.string.clear);
            }
        }.start();
        dialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                countDownTimer.cancel();
            }
        });

        dialog.show();
    }

    private String getString(@StringRes int id) {
        return context.getString(id);
    }

    public interface ICallback {
        void onCleared();
    }
}
