package com.project.survey.ui.instrument.setupstation.util;


import android.content.Context;
import android.graphics.Color;
import android.text.Editable;
import android.text.TextWatcher;

import com.afollestad.materialdialogs.DialogAction;
import com.afollestad.materialdialogs.MaterialDialog;
import com.afollestad.materialdialogs.internal.MDButton;
import com.project.survey.App;
import com.project.survey.R;
import com.rengwuxian.materialedittext.MaterialEditText;

import blankj.utilcode.util.ToastUtils;
import blankj.utilcode.util.Utils;

public class ControlPointsExportDialogUtils {
    private final Context context;

    private MDButton mPositiveAction;

    public ControlPointsExportDialogUtils(Context context) {
        this.context = context;
    }

    MaterialEditText met_export_name;

    public void showExportDialog(ICallback callback) {
        MaterialDialog dialog = new MaterialDialog.Builder(context)
                .title(R.string.export_excel)
                .customView(R.layout.dialog_export_point_config, true)
                .positiveText(R.string.export_points)
                .negativeText(R.string.cancel)
                .onPositive((dialog1, which) -> {
                    String name;
                    if ("".equals(met_export_name.getText().toString().trim())) {
                        ToastUtils.showLong(R.string.file_name_can_not_empty);
                        return;
                    } else {
                        name = met_export_name.getText().toString().trim();
                    }
//                    exportExcelAsync(name, mHeaders);
                    if (callback != null) {
                        callback.onExport(name);
                    }
                })
                .build();

        met_export_name = dialog.getCustomView().findViewById(R.id.dialog_export_point_config_name);
        mPositiveAction = dialog.getActionButton(DialogAction.POSITIVE);

        initMaterialEditTextColor2();

        met_export_name.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {

            }

            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {

            }

            @Override
            public void afterTextChanged(Editable s) {
                if (!"".equals(met_export_name.getText().toString().trim())) {
                    mPositiveAction.setEnabled(true);
                } else {
                    mPositiveAction.setEnabled(false);
                }
            }
        });
        dialog.show();
        mPositiveAction.setEnabled(false);
    }

    private void initMaterialEditTextColor2() {
        if (App.instance.isThemeDark()) {
            met_export_name.setMetTextColor(Color.WHITE);
            met_export_name.setPrimaryColor(Color.LTGRAY);
            met_export_name.setFocusFraction(1.0f);
            met_export_name.setMetHintTextColor(Color.GRAY);
            met_export_name.setUnderlineColor(Color.GRAY);
        }
    }

    public interface ICallback {
        void onExport(String name);
    }
}
