package com.project.survey.ui.instrument.setupstation.util;

import android.content.Context;
import android.graphics.Color;

import com.afollestad.materialdialogs.MaterialDialog;
import com.bingce.utils.ContextProviderUtils;
import com.bingce.utils.IOnSingleGetCallback;
import com.bingce.utils.IProvider;
import com.project.survey.App;
import com.project.survey.R;
import com.rengwuxian.materialedittext.MaterialEditText;

import blankj.utilcode.util.Utils;

public class ControlPointsFilterDialogUtils extends ContextProviderUtils {
    private String point_name_keyword;
    private MaterialEditText met_point_name_keyword;

    public ControlPointsFilterDialogUtils(IProvider<Context> contextIProvider) {
        super(contextIProvider);
    }

    public void showFilterDialog(IOnSingleGetCallback<String> keyCallback) {
        MaterialDialog dialog = new MaterialDialog.Builder(context())
                .title(R.string.filter)
                .customView(R.layout.dialog_control_points_filter, true)
                .onPositive((dialog1, which) -> {
                    point_name_keyword = met_point_name_keyword.getText().toString();

                    if (keyCallback != null) {
                        keyCallback.onGet(point_name_keyword);
                    }
                })
                .positiveText(getString(R.string.confirm))
                .negativeText(getString(R.string.cancel)).build();
        met_point_name_keyword =
                dialog.getCustomView().findViewById(R.id.met_dialog_records_filter_roadname_keyword);

        initMaterialEditTextColor2();

        met_point_name_keyword.setText(point_name_keyword);

        dialog.show();
    }

    private void initMaterialEditTextColor2() {
        if (App.instance.isThemeDark()) {
            met_point_name_keyword.setMetTextColor(Color.WHITE);

            met_point_name_keyword.setPrimaryColor(Color.LTGRAY);

            met_point_name_keyword.setFocusFraction(1.0f);

            met_point_name_keyword.setMetHintTextColor(Color.GRAY);

            met_point_name_keyword.setUnderlineColor(Color.GRAY);
        }
    }
}
