package com.project.survey.ui.instrument.setupstation.util;

import com.bingce.utils.FileUtil;
import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

class JsonStringArray {
    private String name;
    private List<String> strings = new ArrayList<>();

    public JsonStringArray() {
    }

    public JsonStringArray(String name) {
        this.name = name;
        strings = new ArrayList<>();
    }

    public List<String> getStrings() {
        return strings;
    }

    public void setStrings(List<String> strings) {
        this.strings = strings;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public static JsonStringArray read(File folder, String name, String suffix) {
        JsonStringArray jsonStringArray = new JsonStringArray(name);
        File target = new File(folder, name + "." + suffix);
        if (!target.exists()) {
            return jsonStringArray;
        }
        FileUtil.ReadFileResult readFileResult = FileUtil.readStringFrom(target);
        if (readFileResult.success) {
            try {
                List<String> result = gson.fromJson(readFileResult.string, new TypeToken<List<String>>() {
                }.getType());
                if (result != null) {
                    jsonStringArray.strings.addAll(result);
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return jsonStringArray;
    }

    public void save(File folder, String suffix) {
        String json = gson.toJson(strings);
        FileUtil.writeString(json, new File(folder, name + "." + suffix));
    }

    public void clear() {
        strings.clear();
    }

    private static final Gson gson = new Gson();
}
