package com.project.survey.ui.instrument.setupstation.util;

import android.content.Context;

import androidx.annotation.WorkerThread;

import com.bingce.TimeCount;
import com.bingce.constants.FileNameConstants;
import com.bingce.data.database.KeyValueDb;
import com.bingce.data.surveyor.designdata.kv.KeyValueConstants;
import com.bingce.data.surveyor.designdata.kv.KeyValueRecord;

import java.io.File;

public class MigrationBingCeFolderDataUtils {
    @WorkerThread
    public static boolean collectFromBingCeFolder(Context appCompatActivity, File dataFolder, CollectLocalDataInAppStartFirstTimeUtil.ILog log, TimeCount.ITimeCounter timeCounter) {
        if (!dataFolder.exists()) {
            return false;
        }
        File mark = new File(dataFolder, CollectLocalDataInAppStartFirstTimeUtil.COLLECTED_FILE_NAME);
        if (mark.exists()) {//已经收集过了
            log.log("BingCe目录下数据已读取");
            return true;
        }
        log.log("读取坐标系数据");
        //0.收集坐标系模板
        CoordinatorSystemCollectUtils.collectCoordinatorTemplate(new File(dataFolder, FileNameConstants.CONFIG_FILE_EXCEL_COORDINATOR_OF_PROJECT), timeCounter);
        //1.收集全站仪数据
        _1TotalStationCollectUtils.collect(dataFolder, log);
        //遍历目录
        File[] projects = dataFolder.listFiles();
        if (projects == null) {
            return false;
        }
        //遍历项目目录
        for (File project : projects) {
            if (!project.exists() || project.isFile()) {
                continue;
            }
            ProjectDbUtils.collect(appCompatActivity, project, log, timeCounter);
        }
        //生成收集标识
        if (!CollectLocalDataInAppStartFirstTimeUtil.generatorCollectedFile(dataFolder)) {
            KeyValueDb.getInstance().save(new KeyValueRecord(CollectLocalDataInAppStartFirstTimeUtil.GENERATOR_COLLECTED_FILE_FAILURE
                    , KeyValueConstants.VALUE_YES));
        }
        return true;
    }
}
