package com.project.survey.ui.instrument.setupstation.util;

import androidx.annotation.WorkerThread;

import com.bingce.totalstation.TsConfig;
import com.bingce.utils.FileUtil;

import java.io.File;

import blankj.utilcode.util.Utils;

class _1TotalStationCollectUtils {
    @WorkerThread
    static void collect(File appFolder, CollectLocalDataInAppStartFirstTimeUtil.ILog log) {
        log.log("读取全站仪数据...");
        //1.优化读取total_station.json
        File jsonFile = new File(appFolder, TsConfig.CONFIG_FILE);
        if (jsonFile.exists()) {
            FileUtil.ReadFileResult readFileResult = FileUtil.readStringFrom(jsonFile);
            if (readFileResult.success) {
                save(readFileResult.string);
            }
            log.log("完成全站仪数据收集.");
            return;
        }
        //2.读取其他
        File configJsonFile = new File(appFolder, "totalstation.json");
        if (configJsonFile.exists()) {
            FileUtil.ReadFileResult readFileResult = FileUtil.readStringFrom(configJsonFile);
            if (readFileResult.success) {
                save(readFileResult.string);
                log.log("完成全站仪数据收集..");
                return;
            }
        }
        log.log("结束全站仪数据收集.");
    }

    @WorkerThread
    private static void save(String configString) {
        File configJsonFile = new File(Utils.getApp().getFilesDir(), TsConfig.CONFIG_FILE);
        FileUtil.writeString(configString, configJsonFile);
    }
}
