package com.project.survey.ui.lofting.pointlofting.record.util;

import android.content.Context;
import android.view.View;
import android.widget.EditText;

import com.afollestad.materialdialogs.MaterialDialog;
import com.bingce.utils.StringUtil;
import com.project.survey.R;
import com.project.survey.util.CommonUtils;


public class RecordDetailActivityRemarksUtils {
    public static void changeRemarks(Context context, String remarks, IOnRemarksChanged remarksChanged) {
        MaterialDialog dialog = new MaterialDialog.Builder(context)
                .title(R.string.remarks)
                .customView(R.layout.dialog_edit_remarks, false)
                .onPositive((dialog1, which) -> {
                    View contentView = dialog1.getCustomView();
                    if (contentView == null) {
                        return;
                    }
                    EditText met_remarks = contentView.findViewById(R.id.et_dialog_edit_remarks);
                    if (met_remarks == null) {
                        return;
                    }
                    String remarks1 = met_remarks.getText().toString();
                    if (remarksChanged != null && !StringUtil.isEmpty(remarks1)) {
                        remarksChanged.onChanged(remarks1);
                    }
                    CommonUtils.hideSoftInput();
                })
                .positiveText(context.getString(R.string.save))
                .negativeText(context.getString(R.string.cancel))
                .show();

        View contentView = dialog.getCustomView();
        if (contentView != null) {
            EditText editText = contentView.findViewById(R.id.et_dialog_edit_remarks);
            if (editText != null) {
                if (StringUtil.isEmpty(remarks)) {
                    editText.setHint(R.string.empty);
                } else {
                    editText.setText(remarks);
                }
            }
        }
    }

    public interface IOnRemarksChanged {
        void onChanged(String remarks);
    }
}
