package com.project.survey.ui.lofting.pointlofting.record.util;

import android.content.Context;
import android.os.CountDownTimer;

import com.afollestad.materialdialogs.DialogAction;
import com.afollestad.materialdialogs.MaterialDialog;
import com.afollestad.materialdialogs.internal.MDButton;
import com.bingce.utils.ContextProviderUtils;
import com.bingce.utils.IProvider;
import com.project.survey.R;

import blankj.utilcode.util.ToastUtils;

public class RecordsActivityClearUtils extends ContextProviderUtils {
    private MDButton mPositiveAction;

    private final IProvider<Integer> currentTypeFromSpinner;

    public RecordsActivityClearUtils(IProvider<Context> contextIProvider, IProvider<Integer> currentTypeFromSpinner) {
        super(contextIProvider);
        this.currentTypeFromSpinner = currentTypeFromSpinner;
    }

    public void showClearDialog(Runnable clearCallback) {
        if (isCloceFunction()) {
            ToastUtils.showShort("暂不支持");
            return;
        }
        MaterialDialog dialog = new MaterialDialog.Builder(context())
                .title(R.string.warning)
                .content(R.string.confirm_delete_filter_records)
                .positiveText(getString(R.string.clear))
                .negativeText(getString(R.string.cancel))
                .onPositive((dialog1, which) -> {
//                    ProgressDialog mProgressDialog = new ProgressDialog(context());
//                    mProgressDialog.setMessage(getString(R.string.deleting));
//                    mProgressDialog.show();
//                    ThreadPoolUtil.execute(() -> {
//                        IRecordsUtils recordsUtils = recordsUtilsMap.get(currentTypeFromSpinner);
//                        if (recordsUtils != null) {
//                            recordsUtils.clearInWorkerThread(this, mProgressDialog, filterParameter());
//                        }
//                        ToastUtils.showShort(R.string.clean_over);
//                    });
                    if (clearCallback != null) {
                        clearCallback.run();
                    }
                })
                .build();

        mPositiveAction = dialog.getActionButton(DialogAction.POSITIVE);
        mPositiveAction.setEnabled(false);
        final CountDownTimer countDownTimer = new CountDownTimer(5000, 1000) {
            @Override
            public void onTick(long millisUntilFinished) {
                mPositiveAction.setText(getString(R.string.clear) + "(" + millisUntilFinished / 1000 + "s)");
            }

            @Override
            public void onFinish() {
                mPositiveAction.setEnabled(true);
                mPositiveAction.setText(R.string.clear);
            }
        }.start();
        dialog.setOnDismissListener(dialog12 -> countDownTimer.cancel());

        dialog.show();
    }

    /**
     * 是否关闭的功能
     *
     * @return
     */
    private boolean isCloceFunction() {
        return currentTypeFromSpinner.value() == RecordTypeConstants.TYPE_CUSTOM_TIAN_JING_ONE
                || currentTypeFromSpinner.value() == RecordTypeConstants.TYPE_CUSTOM_ZHONG_JIAO_ONE;
    }
}
