package com.project.survey.ui.lofting.pointlofting.record.util;

import android.content.Context;
import android.graphics.Color;
import android.view.Gravity;
import android.view.View;
import android.view.ViewGroup;
import android.widget.RadioGroup;
import android.widget.TextView;

import androidx.appcompat.app.AlertDialog;

import com.bingce.utils.ContextProviderUtils;
import com.bingce.utils.DateUtils;
import com.bingce.utils.IProvider;
import com.kongzue.dialogx.dialogs.BottomDialog;
import com.kongzue.dialogx.dialogs.BottomMenu;
import com.kongzue.dialogx.interfaces.OnBindView;
import com.kongzue.dialogx.interfaces.OnMenuItemClickListener;
import com.project.survey.App;
import com.project.survey.R;
import com.rengwuxian.materialedittext.MaterialEditText;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import blankj.utilcode.util.ToastUtils;
import blankj.utilcode.util.Utils;
import cn.aigestudio.datepicker.views.DatePicker;

public class RecordsActivityFilterUtils extends ContextProviderUtils {
    private int lastFilterPosition = 1;
    private int lastFilterTcsType = 0;
    private Date startDate = DateUtils.reverse2Date(DateUtils.get7DaysStartTime());
    private Date endDate = DateUtils.reverse2Date(DateUtils.getTodayEndTime());
    private MaterialEditText met_roadname_keyword, met_kilometer_keyword, met_remarks_keyword;
    private RadioGroup group;
    private RadioGroup tcsGroup;
    private String roadname_keyword = "", kilometer_keyword = "", remarks_keyword = "";
    private String tcsType;

    private final IProvider<Integer> currentTypeFromSpinner;
    private TextView tv_dialog_date_filter, tv_tcstype_filter;
    private final IProvider<TextView> tv_top_date_filter;
    private final IProvider<TextView> tv_top_dcs_filter;

    public void resetTcsType() {
        tcsType = null;
        lastFilterTcsType = 0;
        tv_top_dcs_filter.value().setVisibility(View.GONE);
    }

    public RecordsActivityFilterUtils(IProvider<Context> contextIProvider, IProvider<Integer> currentTypeFromSpinner, IProvider<TextView> tv_top_date_filter, IProvider<TextView> tv_top_dcs_filter) {
        super(contextIProvider);
        this.currentTypeFromSpinner = currentTypeFromSpinner;
        this.tv_top_date_filter = tv_top_date_filter;
        this.tv_top_dcs_filter = tv_top_dcs_filter;
    }


    private void checkFilterGroup(int checkId, boolean ready2Cal) {
        switch (checkId) {
            case R.id.dialog_records_filter_radio1:
                startDate = DateUtils.reverse2Date(DateUtils.getTodayStartTime());
                endDate = DateUtils.reverse2Date(DateUtils.getTodayEndTime());
//                tv_dialog_date_filter.setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
//                tv_top_date_filter.value().setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
                lastFilterPosition = 0;
                break;
            case R.id.dialog_records_filter_radio2:
                startDate = DateUtils.reverse2Date(DateUtils.get7DaysStartTime());
                endDate = DateUtils.reverse2Date(DateUtils.getTodayEndTime());
//                tv_dialog_date_filter.setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
//                tv_top_date_filter.value().setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
                lastFilterPosition = 1;
                break;
            case R.id.dialog_records_filter_radio3:
                startDate = null;
                endDate = null;
//                tv_dialog_date_filter.setText(R.string.all);
//                tv_top_date_filter.value().setText(R.string.all);
                lastFilterPosition = 2;
                break;
            case R.id.dialog_records_filter_radio4:
                if (!ready2Cal) {
                    showTimePickerDialog();
                }
                break;
        }
    }

    private void checkFilterGroup2(int checkId, boolean ready2Cal) {
        switch (checkId) {
            case 0:
                startDate = DateUtils.reverse2Date(DateUtils.getTodayStartTime());
                endDate = DateUtils.reverse2Date(DateUtils.getTodayEndTime());
//                tv_dialog_date_filter.setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
//                tv_top_date_filter.value().setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
                lastFilterPosition = 0;
                break;
            case 1:
                startDate = DateUtils.reverse2Date(DateUtils.get7DaysStartTime());
                endDate = DateUtils.reverse2Date(DateUtils.getTodayEndTime());
//                tv_dialog_date_filter.setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
//                tv_top_date_filter.value().setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
                lastFilterPosition = 1;
                break;
            case 2:
                startDate = null;
                endDate = null;
//                tv_dialog_date_filter.setText(R.string.all);
//                tv_top_date_filter.value().setText(R.string.all);
                lastFilterPosition = 2;
                break;
            case 3:
                if (!ready2Cal) {
                    showTimePickerDialog();
                }
                break;
        }
    }

    private void checkFilterGroup(int checkId) {
        checkFilterGroup(checkId, false);
    }

    private String[] timeMenuArr;
    private String[] tcsMenuArr;

    public void showTimeFilterDialog(Runnable updateCallback) {
        if (timeMenuArr == null || timeMenuArr.length == 0) {
            timeMenuArr = new String[]{context().getString(R.string.today), context().getString(R.string.within_seven_days), context().getString(R.string.all), context().getString(R.string.custom_time)};
        }
        BottomMenu.build().setMenuList(timeMenuArr)
                .setShowSelectedBackgroundTips(true)
                .setTitle(R.string.time_filter)
                .setOnMenuItemClickListener((dialog, text, index) -> {
                    tv_top_date_filter.value().setText(timeMenuArr[index]);
                    checkFilterGroup2(index, false);
                    if (updateCallback != null) updateCallback.run();
                    return false;
                }).setCancelButton(R.string.cancel).setSelection(lastFilterPosition).show();
    }

    public void showTcsTypeDialog(Runnable updateCallback) {
        if (tcsMenuArr == null || tcsMenuArr.length == 0) {
            tcsMenuArr = new String[]{context().getString(R.string.all), context().getString(R.string.kaiwa), context().getString(R.string.chuzhi), context().getString(R.string.erchen)};
        }
        BottomMenu.build().setMenuList(tcsMenuArr)
                .setShowSelectedBackgroundTips(true)
                .setTitle(R.string.type_filter)
                .setOnMenuItemClickListener(new OnMenuItemClickListener<BottomMenu>() {
                    @Override
                    public boolean onClick(BottomMenu dialog, CharSequence text, int index) {
                        lastFilterTcsType = index;
                        tcsType = index == 0 ? null : tcsMenuArr[index];
                        tv_top_dcs_filter.value().setText(tcsMenuArr[index]);
                        if (updateCallback != null) updateCallback.run();
                        return false;
                    }
                }).setCancelButton(R.string.cancel).setSelection(lastFilterTcsType).show();
    }

    public void showFilterDialog(Runnable updateCallback) {
        BottomDialog.build(new OnBindView<BottomDialog>(R.layout.dialog_records_filter) {
            @Override
            public void onBind(BottomDialog dialog, View v) {
                met_roadname_keyword = v.findViewById(R.id.met_dialog_records_filter_roadname_keyword);
                met_kilometer_keyword = v.findViewById(R.id.met_dialog_records_filter_kilometer_keyword);
                met_remarks_keyword = v.findViewById(R.id.met_dialog_records_filter_remarks_keyword);
                met_roadname_keyword.setText(roadname_keyword);
                met_kilometer_keyword.setText(kilometer_keyword);
                met_remarks_keyword.setText(remarks_keyword);
                if (isHideMetRoadKeyword()) {
                    if (met_roadname_keyword != null) {
                        met_roadname_keyword.setVisibility(View.GONE);
                    }
                }
                if (isHideMetKilometerKeyword()) {
                    if (met_kilometer_keyword != null) {
                        met_kilometer_keyword.setVisibility(View.GONE);
                    }
                }
                if (isHideMetRemarksKeyword()) {
                    if (met_remarks_keyword != null) {
                        met_remarks_keyword.setVisibility(View.GONE);
                    }
                }
                initMaterialEditTextColor2();
            }
        }).setTitle(R.string.other_filter).setOkButton(R.string.confirm, (dialog, v) -> {
            roadname_keyword = met_roadname_keyword.getText().toString();
            kilometer_keyword = met_kilometer_keyword.getText().toString();
            remarks_keyword = met_remarks_keyword.getText().toString();
            if (updateCallback != null) {
                updateCallback.run();
            }
            return false;
        }).setCancelButton(R.string.cancel).show();
//        MaterialDialog dialog = new MaterialDialog.Builder(context())
//                .title(R.string.filter)
//                .customView(R.layout.dialog_records_filter, true)
//                .onPositive((dialog1, which) -> {
//                    roadname_keyword = met_roadname_keyword.getText().toString();
//                    kilometer_keyword = met_kilometer_keyword.getText().toString();
//                    remarks_keyword = met_remarks_keyword.getText().toString();
//                    if (type == RecordTypeConstants.TYPE_TUNNEL_BACK_BREAK){
//                        RadioButton crb = tcsGroup.findViewById(tcsGroup.getCheckedRadioButtonId());
//                        String crbTxt = crb.getText().toString();
//                        lastFilterTcsType = tcsGroup.indexOfChild(crb);
//                        if (context().getString(R.string.all).equals(crbTxt)){
//                            tcsType = null;
//                        }else {
//                            tcsType = crbTxt;
//                        }
//                    }else {
//                        tcsType = null;
//                    }
//                    //读取设置信息
//                    int checkId = group.getCheckedRadioButtonId();
//                    checkFilterGroup(checkId, true);
////                    updateRecyclerView();
//                    if (updateCallback != null) {
//                        updateCallback.run();
//                    }
//                })
//                .positiveText(context().getString(R.string.confirm))
//                .negativeText(context().getString(R.string.cancel)).build();
//
//        tv_dialog_date_filter =
//                dialog.getCustomView().findViewById(R.id.tv_dialog_records_filter_period_of_time);
//        tv_tcstype_filter = dialog.getCustomView().findViewById(R.id.tv_dialog_records_filter_period_of_tcstype);
//        tcsGroup = dialog.getCustomView().findViewById(R.id.radiogroup_dialog_records_filter_tcstype);
//        group = dialog.getCustomView().findViewById(R.id.radiogroup_dialog_records_filter_time);
//        met_roadname_keyword =
//                dialog.getCustomView().findViewById(R.id.met_dialog_records_filter_roadname_keyword);
//        if (type == RecordTypeConstants.TYPE_TUNNEL_BACK_BREAK){
//            tv_tcstype_filter.setVisibility(View.VISIBLE);
//            tcsGroup.setVisibility(View.VISIBLE);
//        }
//        if (isHideMetRoadKeyword()) {
//            if (met_roadname_keyword != null) {
//                met_roadname_keyword.setVisibility(View.GONE);
//            }
//        }
//
//        met_kilometer_keyword =
//                dialog.getCustomView().findViewById(R.id.met_dialog_records_filter_kilometer_keyword);
//
//        if (isHideMetKilometerKeyword()) {
//            if (met_kilometer_keyword != null) {
//                met_kilometer_keyword.setVisibility(View.GONE);
//            }
//        }
//
//        met_remarks_keyword =
//                dialog.getCustomView().findViewById(R.id.met_dialog_records_filter_remarks_keyword);
//
//        if (isHideMetRemarksKeyword()) {
//            if (met_remarks_keyword != null) {
//                met_remarks_keyword.setVisibility(View.GONE);
//            }
//        }
//
//        initMaterialEditTextColor2();
//
//        met_roadname_keyword.setText(roadname_keyword);
//        met_kilometer_keyword.setText(kilometer_keyword);
//        met_remarks_keyword.setText(remarks_keyword);
//
//        switch (lastFilterPosition) {
//            case 0:
//                ((RadioButton) dialog.getCustomView().findViewById(R.id.dialog_records_filter_radio1)).setChecked(true);
//                break;
//            case 1:
//                ((RadioButton) dialog.getCustomView().findViewById(R.id.dialog_records_filter_radio2)).setChecked(true);
//                break;
//            case 2:
//                ((RadioButton) dialog.getCustomView().findViewById(R.id.dialog_records_filter_radio3)).setChecked(true);
//                break;
//            case 3:
//                ((RadioButton) dialog.getCustomView().findViewById(R.id.dialog_records_filter_radio4)).setChecked(true);
//                break;
//        }
//        ((RadioButton)tcsGroup.getChildAt(lastFilterTcsType)).setChecked(true);
//
//        group.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
//            @Override
//            public void onCheckedChanged(RadioGroup radioGroup, int checkId) {
//                checkFilterGroup(checkId);
//            }
//        });
//
//        dialog.show();
    }

    private void showTimePickerDialog() {
        final AlertDialog dialog = new AlertDialog.Builder(context()).create();
        dialog.show();

        DatePicker datePicker = new DatePicker(context());

        Calendar calendar = Calendar.getInstance();
        datePicker.setDate(calendar.get(Calendar.YEAR), calendar.get(Calendar.MONTH) + 1);
        datePicker.setOnDateSelectedListener(new DatePicker.OnDateSelectedListener() {
            @Override
            public void onDateSelected(List<String> date) {
                if (date.size() == 0) {
                    ToastUtils.showShort(R.string.not_choose_date);
                    return;
                }
                Date min = new Date();
                Date max = new Date(0);
                if (date.size() == 1) {
                    startDate =
                            DateUtils.reverse2Date(DateUtils.toDate(DateUtils.reverse2Date(date.get(0))) + " 00:00:00");
                    endDate =
                            DateUtils.reverse2Date(DateUtils.toDate(DateUtils.reverse2Date(date.get(0))) + " 23:59:59");
//                    tv_dialog_date_filter.setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
//                    tv_top_date_filter.value().setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
                    lastFilterPosition = 1;
                } else if (date.size() > 1) {
                    for (int i = 0; i < date.size(); i++) {
                        if (DateUtils.reverse2Date(date.get(i)).after(max))
                            max = DateUtils.reverse2Date(date.get(i));
                        if (DateUtils.reverse2Date(date.get(i)).before(min))
                            min = DateUtils.reverse2Date(date.get(i));
                    }
                    if (max.after(min)) {
                        startDate = DateUtils.reverse2Date(DateUtils.toDate(min) + " 00:00:00");
                        endDate = DateUtils.reverse2Date(DateUtils.toDate(max) + " 23:59:59");
//                        tv_dialog_date_filter.setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
//                        tv_top_date_filter.value().setText(DateUtils.toDate(startDate) + "~" + DateUtils.toDate(endDate));
                        lastFilterPosition = 1;
                    }
                }
                dialog.dismiss();
            }
        });

        ViewGroup.LayoutParams params = new ViewGroup.LayoutParams(ViewGroup.LayoutParams
                .WRAP_CONTENT, ViewGroup.LayoutParams.WRAP_CONTENT);
        dialog.getWindow().setContentView(datePicker, params);
        dialog.getWindow().setGravity(Gravity.CENTER);
    }

    private void initMaterialEditTextColor2() {
        if (App.instance.isThemeDark()) {
            met_roadname_keyword.setMetTextColor(Color.WHITE);
            met_kilometer_keyword.setMetTextColor(Color.WHITE);
            met_remarks_keyword.setMetTextColor(Color.WHITE);

            met_roadname_keyword.setPrimaryColor(Color.LTGRAY);
            met_kilometer_keyword.setPrimaryColor(Color.LTGRAY);
            met_remarks_keyword.setPrimaryColor(Color.LTGRAY);

            met_roadname_keyword.setFocusFraction(1.0f);
            met_kilometer_keyword.setFocusFraction(1.0f);
            met_remarks_keyword.setFocusFraction(1.0f);

            met_roadname_keyword.setHelperTextColor(Color.GRAY);
            met_kilometer_keyword.setHelperTextColor(Color.GRAY);
            met_remarks_keyword.setHelperTextColor(Color.GRAY);

            met_roadname_keyword.setMetHintTextColor(Color.GRAY);
            met_kilometer_keyword.setMetHintTextColor(Color.GRAY);
            met_remarks_keyword.setMetHintTextColor(Color.GRAY);

            met_roadname_keyword.setUnderlineColor(Color.GRAY);
            met_kilometer_keyword.setUnderlineColor(Color.GRAY);
            met_remarks_keyword.setUnderlineColor(Color.GRAY);
        }
    }

    public String road() {
        return roadname_keyword;
    }

    public String k() {
        return kilometer_keyword;
    }

    public String remarks() {
        return remarks_keyword;
    }

    public Date start() {
        return startDate;
    }

    public Date end() {
        return endDate;
    }

    public RecordsActivityFilterParameter filterParameter() {
        return new RecordsActivityFilterParameter(road(), k(), remarks(), start(), end(), tcsType);
    }

    /**
     * 是否隐藏里程过滤
     *
     * @return true 隐藏
     */
    private boolean isHideMetKilometerKeyword() {
        return currentTypeFromSpinner.value() == RecordTypeConstants.TYPE_FREEDOM_SIDE
                || currentTypeFromSpinner.value() == RecordTypeConstants.TYPE_POINT_STAKE;
    }

    /**
     * 是否隐藏road过滤
     */
    private boolean isHideMetRoadKeyword() {
        return currentTypeFromSpinner.value() == RecordTypeConstants.TYPE_MEASURING_TAPE;
    }

    /**
     * 是否隐藏remarks过滤
     */
    private boolean isHideMetRemarksKeyword() {
        return currentTypeFromSpinner.value() == RecordTypeConstants.TYPE_MEASURING_TAPE;
    }

    private boolean isWaterPipKeyword() {
        return currentTypeFromSpinner.value() == RecordTypeConstants.TYPE_WATER_PIPE_BACK_BREAK;
    }
}
