package com.project.survey.ui.lofting.pointlofting.record.util;

import android.content.Context;

import com.bingce.utils.ContextProviderUtils;
import com.bingce.utils.IProvider;
import com.project.survey.R;

public class RecordsActivityHeaders extends ContextProviderUtils {
    public String[] mHeaders01, mHeaders02, mHeaders03, mHeaders11, mHeaders12, mHeaders13,
            mHeaders21, mHeaders22, mHeaders23, mHeaders24,
            mHeaders3, mHeaders41, mHeaders42, mHeaders43, mHeaders51, mHeaders52, mHeaders53,
            mHeaders61, mHeaders62, mHeaders63, mHeaders7;

    public String[] mHeadersBridgeStaking;
    public String[] mHeadersRotaryBridge;
    public String[] mHeadersBridge2Staking;

    public RecordsActivityHeaders(IProvider<Context> contextIProvider) {
        super(contextIProvider);
    }

    public void initHeaders() {
        initSideCommonHeaders();
        initSideFreedomHeaders();
        initKnowPointSettingOutHeaders();
    }

    private void initSideCommonHeaders() {
        mHeaders41 = new String[]{getString(R.string.road_name), getString(R.string.fill_cut),
                getString(R.string.side_name), getString(R.string.move_left_right),
                getString(R.string.move_up_down), getString(R.string.back_break)
                , getString(R.string.move_left_right_to_feature_point),
                getString(R.string.move_up_down_to_feature_point),
                getString(R.string.measured_x_k), getString(R.string.measured_y_d),
                getString(R.string.measured_z), getString(R.string.k)
                , getString(R.string.d), getString(R.string.design_h),
                getString(R.string.longitudinal_slope), getString(R.string.roadbed_edge_h),
                getString(R.string.roadbed_edge_d), getString(R.string.orientation)
                , getString(R.string.remarks), getString(R.string.record_time)};
        mHeaders42 = new String[]{getString(R.string.position_type),
                getString(R.string.station_type), getString(R.string.satellite)
                , "hrms", "vrms", getString(R.string.diff_age), getString(R.string.battery)};
        mHeaders43 = new String[]{getString(R.string.hr)};
    }

    private void initSideFreedomHeaders() {
        mHeaders51 = new String[]{getString(R.string.road_name), getString(R.string.begin_x),
                getString(R.string.begin_y), getString(R.string.begin_z),
                getString(R.string.end_x), getString(R.string.end_y), getString(R.string.end_z)
                , getString(R.string.fill_cut), getString(R.string.side_name),
                getString(R.string.move_left_right), getString(R.string.move_up_down),
                getString(R.string.back_break)
                , getString(R.string.move_left_right_to_feature_point),
                getString(R.string.move_up_down_to_feature_point), getString(R.string.measured_x)
                , getString(R.string.measured_y), getString(R.string.measured_z),
                getString(R.string.k)
                , getString(R.string.d), getString(R.string.design_h),
                getString(R.string.longitudinal_slope), getString(R.string.roadbed_edge_h),
                getString(R.string.roadbed_edge_d), getString(R.string.orientation)
                , getString(R.string.remarks), getString(R.string.record_time)};
        mHeaders52 = new String[]{getString(R.string.position_type),
                getString(R.string.station_type), getString(R.string.satellite)
                , "hrms", "vrms", getString(R.string.diff_age), getString(R.string.battery)};
        mHeaders53 = new String[]{getString(R.string.hr)};
    }

    private void initKnowPointSettingOutHeaders() {
        mHeaders61 = new String[]{getString(R.string.road_name), getString(R.string.point_name)
                , getString(R.string.design_x), getString(R.string.design_y), getString(R.string.design_z)
                , getString(R.string.measured_x), getString(R.string.measured_y), getString(R.string.measured_z)
                , getString(R.string.distance), getString(R.string.move_up_down)
                , getString(R.string.move_k), getString(R.string.move_d)
                , getString(R.string.move_west_east), getString(R.string.move_north_south)
                , getString(R.string.move_fore_back), getString(R.string.move_left_right)
                , getString(R.string.remarks), getString(R.string.record_time)};
        mHeaders62 = new String[]{getString(R.string.position_type),
                getString(R.string.station_type), getString(R.string.satellite)
                , "hrms", "vrms", getString(R.string.diff_age), getString(R.string.battery)};
        mHeaders63 = new String[]{getString(R.string.hr)};
    }

}
