package com.project.survey.ui.lofting.pointlofting.record.util;

import androidx.appcompat.app.AppCompatActivity;

import java.util.LinkedHashMap;
import java.util.Map;

public class RecordsUtilsFactory {
    public static Map<Integer, IRecordsUtils> buildUtils(AppCompatActivity appCompatActivity) {
        return buildUtils(appCompatActivity, recordType -> RecordTypeConstants.TYPE_MEASURING_TAPE != recordType);
    }

    public static Map<Integer, IRecordsUtils> buildUtils(AppCompatActivity appCompatActivity, IFilter filter) {
        return new LinkedHashMap<Integer, IRecordsUtils>() {{
            if (filter == null || filter.isValidate(RecordTypeConstants.TYPE_POINT_STAKE)) {
                put(RecordTypeConstants.TYPE_POINT_STAKE, new PointStakeListUtils(() -> appCompatActivity));
            }
        }};
    }

    public interface IFilter {
        boolean isValidate(int recordType);
    }
}
