package com.project.survey.ui.login

import androidx.core.widget.addTextChangedListener
import com.project.survey.databinding.ActivityForgetPwdBinding
import com.project.survey.extend.setOnClickNoRepeatListener
import com.project.survey.ui.base.BaseBindingActivity
import com.project.survey.util.ActivityNavUtil

/**
 * 忘记密码
 */
class ForgetPwdActivity : BaseBindingActivity<ActivityForgetPwdBinding>() {

    companion object {
        fun start() {
            ActivityNavUtil.startActivity<ForgetPwdActivity> { }
        }
    }

    override fun getBinding(): ActivityForgetPwdBinding =
        ActivityForgetPwdBinding.inflate(layoutInflater)

    override fun initView() {
        immersionToolbar(mBinding.toolbar)

        mBinding.etAccount.addTextChangedListener {
            mBinding.tvSendCode.isEnabled = it?.isNotEmpty() == true;
        }

        mBinding.tvSendCode.setOnClickNoRepeatListener {
            ForgetPwdInputCodeActivity.start()
        }
    }

    override fun initData() {

    }

    override fun initListener() {

    }

}