package com.project.survey.ui.login

import androidx.lifecycle.lifecycleScope
import com.project.survey.databinding.ActivityForgetPwdInputCodeBinding
import com.project.survey.extend.showSoftInput
import com.project.survey.ui.base.BaseBindingActivity
import com.project.survey.util.ActivityNavUtil
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch

/**
 * 忘记密码后的输入验证码
 */
class ForgetPwdInputCodeActivity : BaseBindingActivity<ActivityForgetPwdInputCodeBinding>() {

    companion object {
        fun start() {
            ActivityNavUtil.startActivity<ForgetPwdInputCodeActivity> { }
        }
    }

    override fun getBinding(): ActivityForgetPwdInputCodeBinding =
        ActivityForgetPwdInputCodeBinding.inflate(layoutInflater)

    override fun initView() {
        immersionToolbar(mBinding.toolbar)

        lifecycleScope.launch {
            delay(500L)
            mBinding.etInputCode.firstEditText?.showSoftInput()
        }
    }

    override fun initData() {

    }

    override fun initListener() {
        mBinding.etInputCode.setOnInputListener {
            SetNewPwdActivity.start(it)
        }
    }

}