package com.project.survey.ui.pointmeasure.adapter

import android.content.Context
import android.view.ViewGroup
import com.chad.library.adapter4.BaseQuickAdapter
import com.chad.library.adapter4.viewholder.QuickViewHolder
import com.project.survey.R
import com.project.survey.constants.AdapterConstants
import com.project.survey.constants.Constants
import com.project.survey.constants.SPConstants
import com.project.survey.model.MeasureBean
import com.project.survey.util.SPUtils

class PointMeasureListAdapter(val type: String) : BaseQuickAdapter<MeasureBean, QuickViewHolder>() {

    override fun onBindViewHolder(holder: QuickViewHolder, position: Int, item: MeasureBean?) {
        if (item == null) return

        // true测量计划，false工程计量
        val isCLJH = type == Constants.TYPE_BD_CLJH
        holder.setText(R.id.tvName, if (isCLJH) item.CLJH_LCMC else item.GCJL_LCMC)
            .setText(R.id.tvNO, if (isCLJH) item.CLJH_BDLSH else item.GCJL_BDLSH)
            .setText(R.id.tvType, item.CLJH_CLLX_NAME)
            .setGone(R.id.tvType, !isCLJH)
            .setText(R.id.tvProjectName, item.BD_FBFXPZ_FXGCMC)
            .setText(
                R.id.tvMeasureContentKey,
                if (isCLJH) "测  量  内  容 ：" else "计  量  内  容 ："
            )
            .setText(R.id.tvMeasureContent, if (isCLJH) item.CLJH_CONTENT else item.GCJL_JLNR)
            .setText(R.id.tvApplyUser, item.SY_CREATEUSERNAME)
//            .setVisible(R.id.tvGenerateForm, isCLJH)
            .setVisible(R.id.tvGenerateForm, false)

            .setEnabled(R.id.tvGenerateForm, "已结束" == item.CLJH_WORKSTATUS)
        if (isCLJH) {
//            holder.setEnabled(R.id.tvStopMeasure, "执行中" == item.CLJH_WORKSTATUS)
//                .setEnabled(
//                    R.id.tvEnterMeasure,
//                    "执行中" == item.CLJH_WORKSTATUS || "待执行" == item.CLJH_WORKSTATUS || item.CLJH_WORKSTATUS.isNullOrBlank()
//                )
            // CLJH_WJSCLRY 根据当前账号名字是否在此字段
            val personName = SPUtils.getString(SPConstants.PERSON_NAME)
            val enable = item.CLJH_WJSCLRY.split(",").contains(personName) && personName.isNotBlank()
            holder.setEnabled(R.id.tvStopMeasure, enable)
                .setEnabled(R.id.tvEnterMeasure, enable)
        } else {
            holder.setEnabled(R.id.tvStopMeasure, "执行中" == item.GCJL_WORKSTATUS)
                .setEnabled(
                    R.id.tvEnterMeasure,
                    "执行中" == item.GCJL_WORKSTATUS || "待执行" == item.GCJL_WORKSTATUS || item.GCJL_WORKSTATUS.isNullOrBlank()
                )
        }
    }

    override fun onCreateViewHolder(
        context: Context,
        parent: ViewGroup,
        viewType: Int
    ): QuickViewHolder {
        return QuickViewHolder(R.layout.item_point_measure_list, parent)
    }

    override fun onBindViewHolder(
        holder: QuickViewHolder,
        position: Int,
        item: MeasureBean?,
        payloads: List<Any>
    ) {
        super.onBindViewHolder(holder, position, item, payloads)
        if (payloads.isNotEmpty() && payloads[0] is Int && item != null) {
            // true测量计划，false工程计量
            val isCLJH = type == Constants.TYPE_BD_CLJH
            val type = payloads[0] as Int
            if (type == AdapterConstants.WORK_STATUS) {
                holder.setEnabled(R.id.tvGenerateForm, "已结束" == item.CLJH_WORKSTATUS)
                if (isCLJH) {
//                    holder.setEnabled(R.id.tvStopMeasure, "执行中" == item.CLJH_WORKSTATUS)
//                        .setEnabled(
//                            R.id.tvEnterMeasure,
//                            "执行中" == item.CLJH_WORKSTATUS || "待执行" == item.CLJH_WORKSTATUS || item.CLJH_WORKSTATUS.isNullOrBlank()
//                        )
                    // CLJH_WJSCLRY 根据当前账号名字是否在此字段
                    val personName = SPUtils.getString(SPConstants.PERSON_NAME)
                    val enable = item.CLJH_WJSCLRY.split(",").contains(personName) && personName.isNotBlank()
                    holder.setEnabled(R.id.tvStopMeasure, enable)
                        .setEnabled(R.id.tvEnterMeasure, enable)
                } else {
                    holder.setEnabled(R.id.tvStopMeasure, "执行中" == item.GCJL_WORKSTATUS)
                        .setEnabled(
                            R.id.tvEnterMeasure,
                            "执行中" == item.GCJL_WORKSTATUS || "待执行" == item.GCJL_WORKSTATUS || item.GCJL_WORKSTATUS.isNullOrBlank()
                        )
                }
            }
        }
    }
}