package com.project.survey.ui.pointmeasure.measure;

import android.content.Context;
import android.content.Intent;
import android.view.View;

import androidx.recyclerview.widget.DefaultItemAnimator;
import androidx.recyclerview.widget.LinearLayoutManager;

import com.project.survey.R;
import com.project.survey.databinding.ActivityControlRecordListBinding;
import com.project.survey.model.ControlRecord;
import com.project.survey.ui.base.BaseSurveyNewActivity;
import com.project.survey.ui.pointmeasure.measure.adapter.ControlRecordListAdapter;

import java.io.Serializable;
import java.util.List;

public class ControlRecordListActivity extends BaseSurveyNewActivity {

    private ActivityControlRecordListBinding binding;

    @Override
    public View getContentView() {
        binding = ActivityControlRecordListBinding.inflate(getLayoutInflater());
        return binding.getRoot();
    }

    @Override
    protected void initView() {
        setTitle(getString(R.string.record_list));
    }

    @Override
    protected void initData() {
        ControlRecordListAdapter adapter = new ControlRecordListAdapter(ControlRecordListActivity.this, (List<ControlRecord>) getIntent().getSerializableExtra(POINT_INFO));
        LinearLayoutManager linearLayoutManager = new LinearLayoutManager(ControlRecordListActivity.this);
        linearLayoutManager.setOrientation(LinearLayoutManager.VERTICAL);
        binding.recyclerView.setLayoutManager(linearLayoutManager);
        binding.recyclerView.setAdapter(adapter);
        binding.recyclerView.setItemAnimator(new DefaultItemAnimator());
    }


    private static String POINT_INFO = "control_point_list_info";

    public static void start(Context context, List<ControlRecord> pointList){
        Intent intent = new Intent(context, ControlRecordListActivity.class);
        intent.putExtra(POINT_INFO, (Serializable) pointList);
        context.startActivity(intent);
    }
}