package com.project.survey.ui.pointmeasure.measure.adapter;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bingce.utils.Util;
import com.project.survey.R;
import com.project.survey.model.ControlRecord;

import java.util.List;

public class ControlRecordListAdapter extends RecyclerView.Adapter<ControlRecordListAdapter.ViewHolder> {

    private Context mContext;
    private List<ControlRecord> list;

    public ControlRecordListAdapter(Context context, List<ControlRecord> list) {
        this.mContext = context;
        this.list = list;
    }

    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        return new ViewHolder(LayoutInflater.from(mContext).inflate(R.layout.layout_control_record_item, parent, false));
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        holder.tv_point_name.setText(list.get(position).getPointName());
        if (position == 0) {
            holder.tv_prompt.setText(mContext.getString(R.string.average_coordinates_calculation_way));
        }
        holder.tv_x.setText("X：" + Util.formatDouble2String(list.get(position).getX(), 6));
        holder.tv_y.setText("Y：" + Util.formatDouble2String(list.get(position).getY(), 6));
        holder.tv_z.setText("Z：" + Util.formatDouble2String(list.get(position).getZ(), 6));
        holder.tv_latitude.setText(mContext.getString(R.string.latitude) + "：" + Util.formatDouble2String(list.get(position).getLatitude(), 6));
        holder.tv_longitude.setText(mContext.getString(R.string.longitude) + "：" + Util.formatDouble2String(list.get(position).getLongitude(), 6));
        holder.tv_altitude.setText(mContext.getString(R.string.altitude) + "：" + Util.formatDouble2String(list.get(position).getAltitude(), 6));
    }

    @Override
    public int getItemCount() {
        return list == null ? 0 : list.size();
    }

    public class ViewHolder extends RecyclerView.ViewHolder {
        TextView tv_x, tv_y, tv_z, tv_latitude, tv_longitude, tv_altitude, tv_point_name, tv_prompt;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            tv_x = itemView.findViewById(R.id.tv_x);
            tv_y = itemView.findViewById(R.id.tv_y);
            tv_z = itemView.findViewById(R.id.tv_z);
            tv_latitude = itemView.findViewById(R.id.tv_latitude);
            tv_longitude = itemView.findViewById(R.id.tv_longitude);
            tv_altitude = itemView.findViewById(R.id.tv_altitude);
            tv_point_name = itemView.findViewById(R.id.tv_point_name);
            tv_prompt = itemView.findViewById(R.id.tv_prompt);
        }
    }
}
