package com.project.survey.ui.pointmeasure.measure.util;

import android.content.Context;
import android.content.SharedPreferences;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.project.survey.R;
import com.project.survey.widget.bingce.dragdrop.FunctionItem;
import com.project.survey.widget.bingce.dragdrop.TabItem;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;


/**
 * Created by xulc on 2018/6/29.
 */

public class SFUtils {
    private Context context;
    private String xmlFileName;
    private String preferAllDataKey;
    private String preferSelDataKey;
    private String str;
    private SharedPreferences sp = null;

    public SFUtils(Context context, String xmlFileName, String preferAllDataKey, String preferSelDataKey, String strDefultDataValue) {
        this.context = context;
        this.xmlFileName = xmlFileName;
        this.preferAllDataKey = preferAllDataKey;
        this.preferSelDataKey = preferSelDataKey;
        this.str = strDefultDataValue;
        sp = context.getSharedPreferences("survey_bottom_all_information", Context.MODE_PRIVATE);
    }

    public List<FunctionItem> getAllFunctionWithState() {
        String allData = sp.getString(preferAllDataKey, "");
        List<FunctionItem> functionItems = new ArrayList<>();
        List<TabItem> tabItems = null;
        if ("".equals(allData)) {
            try {
                InputStream is = context.getAssets().open(xmlFileName + ".xml");
                InputStreamReader isr = new InputStreamReader(is);
                BufferedReader br = new BufferedReader(isr);
                String str = null;
                StringBuffer sbuffer = new StringBuffer();
                while ((str = br.readLine()) != null) {
                    sbuffer.append(str);
                }
                br.close();
                isr.close();
                is.close();
                allData = sbuffer.toString();
                Gson gson = new Gson();
                tabItems = gson.fromJson(allData, new TypeToken<List<TabItem>>() {
                }.getType());
                if (tabItems != null) {
                    for (int i = 0; i < tabItems.size(); i++) {
                        FunctionItem functionItem = new FunctionItem(tabItems.get(i).getTabName(), tabItems.get(i).getTabTip(), true);
                        functionItems.add(functionItem);
                        functionItems.addAll(tabItems.get(i).getFunctionItems());
                    }
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        } else {
            Gson gson = new Gson();
            functionItems = gson.fromJson(allData, new TypeToken<List<FunctionItem>>() {
            }.getType());
        }
        return functionItems;
    }

    public List<FunctionItem> getSelectFunctionItem() {
        String selData = sp.getString(preferSelDataKey, str);
        List<FunctionItem> functionItems = null;
        if ("".equals(selData)) {
            functionItems = new ArrayList<>();
        } else {
            Gson gson = new Gson();
            functionItems = gson.fromJson(selData, new TypeToken<List<FunctionItem>>() {
            }.getType());
        }
        return functionItems;
    }

    public List<FunctionItem> getTabNames() {
        String allData = sp.getString(preferAllDataKey, "");
        List<FunctionItem> functionItems = new ArrayList<>();
        List<TabItem> tabItems = null;
        if ("".equals(allData)) {
            try {
                InputStream is = context.getAssets().open(xmlFileName + ".txt");
                InputStreamReader isr = new InputStreamReader(is);
                BufferedReader br = new BufferedReader(isr);
                String str = null;
                StringBuffer sbuffer = new StringBuffer();
                while ((str = br.readLine()) != null) {
                    sbuffer.append(str);
                }
                br.close();
                isr.close();
                is.close();
                allData = sbuffer.toString();
                Gson gson = new Gson();
                tabItems = gson.fromJson(allData, new TypeToken<List<TabItem>>() {
                }.getType());
                if (tabItems != null) {
                    int tabItemsCount = 0; //用于标记之后滑动的位置
                    for (int i = 0; i < tabItems.size(); i++) {
                        FunctionItem functionItem = new FunctionItem(tabItems.get(i).getTabName(), tabItems.get(i).getTabTip(), true, tabItemsCount);
                        tabItemsCount = tabItemsCount + tabItems.get(i).getFunctionItems().size() + 1;
                        functionItems.add(functionItem);
                    }
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return functionItems;
    }

    public void saveSelectFunctionItem(List<FunctionItem> selData) {
        Gson gson = new Gson();
        sp.edit().putString(preferSelDataKey, gson.toJson(selData)).apply();
    }

    public void saveAllFunctionWithState(List<FunctionItem> allData) {
        Gson gson = new Gson();
        sp.edit().putString(preferAllDataKey, gson.toJson(allData)).apply();
    }

    public static String getFunctionJsonNameLanguage(Context context, String jsonName) {
        String showText = "";
        switch (jsonName) {
            case "坐标信息":
                showText = context.getString(R.string.coordinate_information);
                break;
            case "基站信息":
                showText = context.getString(R.string.base_information);
                break;
            case "测量信息":
                showText = context.getString(R.string.survey_information);
                break;
            case "投影距离：与上一个点的投影距离。（空间距离同理）":
                showText = context.getString(R.string.projection_space_distance_comment);
                break;
            case "X":
                showText = "X";
                break;
            case "Y":
                showText = "Y";
                break;
            case "Z":
                showText = "Z";
                break;
            case "纬度":
                showText = context.getString(R.string.latitude);
                break;
            case "经度":
                showText = context.getString(R.string.longitude);
                break;
            case "海拔":
                showText = context.getString(R.string.altitude);
                break;
            case "基站ID":
                showText = context.getString(R.string.base_id);
                break;
            case "基站距离":
                showText = context.getString(R.string.base_distance);
                break;
            case "速度":
                showText = context.getString(R.string.speed);
                break;
            case "前进方位":
                showText = context.getString(R.string.forward_angle);
                break;
            case "投影距离":
                showText = context.getString(R.string.projection_distance);
                break;
            case "空间距离":
                showText = context.getString(R.string.space_distance);
                break;
            case "计算信息":
                showText = context.getString(R.string.computational_information);
                break;
            case "累计平距":
                showText = context.getString(R.string.add_up_plane_distance);
                break;
            case "累计斜距":
                showText = context.getString(R.string.add_up_space_distance);
                break;
            case "目标信息":
                showText = context.getString(R.string.target_information);
                break;
            case "实测信息":
                showText = context.getString(R.string.measured_information);
                break;
            case "距离信息":
                showText = context.getString(R.string.distance_information);
                break;
            case "（请注意仅用于选线放样功能）":
                showText = context.getString(R.string.please_note_select_line_function);
                break;
            case "目标 X":
                showText = context.getString(R.string.target_x);
                break;
            case "目标 Y":
                showText = context.getString(R.string.target_y);
                break;
            case "目标 Z":
                showText = context.getString(R.string.target_z);
                break;
            case "目标里程":
                showText = context.getString(R.string.target_mileage);
                break;
            case "目标偏距":
                showText = context.getString(R.string.target_offset);
                break;
            case "设计标高":
                showText = context.getString(R.string.design_height);
                break;
            case "实测 X":
                showText = context.getString(R.string.survey_x);
                break;
            case "实测 Y":
                showText = context.getString(R.string.survey_y);
                break;
            case "实测 Z":
                showText = context.getString(R.string.survey_z);
                break;
            case "实测里程":
                showText = context.getString(R.string.survey_mileage);
                break;
            case "实测偏距":
                showText = context.getString(R.string.survey_offset);
                break;
            case "起点距":
                showText = context.getString(R.string.start_distance);
                break;
            case "终点距":
                showText = context.getString(R.string.end_distance);
                break;
            case "垂距":
                showText = context.getString(R.string.vertical_distance);
                break;
        }
        return showText;
    }
}
