package com.project.survey.util;

import android.content.Context;

import com.bingce.utils.FileUtil;
import com.project.survey.R;

import java.io.File;


public class ExportPathUtils {
    public static File exportFolder(Context context, String folderName) {
        File exportFolder = new File(FileUtil.getSDPath(), context.getString(R.string.surveyor_exported_file));
        if (!exportFolder.exists() && !exportFolder.mkdirs()) {
            return backupExportFolder(context, folderName);
        }
        File folder = new File(exportFolder, folderName);
        if (!folder.exists() && !folder.mkdirs()) {
            return backupExportFolder(context, folderName);
        }
        return folder;
    }

    private static File backupExportFolder(Context context, String folderName) {
        File cachedFolder = new File(context.getExternalCacheDir(), folderName);
        if (!cachedFolder.exists() && !cachedFolder.mkdirs()) {
            return context.getExternalCacheDir();
        }
        return cachedFolder;
    }

    public static String filterDuplicateFileName(File folder, String fileName, String fileSuffix) {
        if (folder == null || !folder.exists() || folder.isFile()) {
            return fileName;
        }
        File file = new File(folder, fileName + "." + fileSuffix);
        if (!file.exists() || file.isDirectory()) {
            return fileName;
        }
        int index = 1;
        while (true) {
            file = new File(folder, fileName + "_" + index + "." + fileSuffix);
            if (!file.exists() || file.isDirectory()) {
                return fileName + "_" + index;
            }
            index++;
        }
    }
}
