package com.project.survey.util

import com.bingce.coordlib.model.CoordinateSystem
import com.bingce.data.base.user.UserConfig
import com.bingce.data.base.user.UserConfigConstants
import com.bingce.data.database.AppDataBase
import com.bingce.data.database.KeyValueDb
import com.bingce.data.database.ProjectDb
import com.bingce.data.surveyor.designdata.kv.KeyValueConstants
import com.bingce.data.surveyor.designdata.kv.KeyValueRecord
import com.bingce.data.surveyor.designdata.project.ProjectRecord
import com.bingce.utils.ThreadPoolUtil
import com.project.survey.App
import com.project.survey.BuildConfig
import com.project.survey.constants.SPConstants
import java.util.Date

object MockUtil {

    val isTest = "shsx_test" == BuildConfig.FLAVOR

    fun login() {
        SPUtils.put(SPConstants.ACCOUNT, "zhangsan")
        SPUtils.put(SPConstants.TOKEN, "1234567890")
        val personId = "123456"
        SPUtils.put(SPConstants.PERSON_ID, personId)
        SPUtils.put(SPConstants.MOBILE_PHONE, "15911112222")

        // 进入项目，设置当前项目
        val projectId = "111111"
        SPUtils.put(SPConstants.PROJECT_ID, projectId)

        // 存储配置--当前项目
        ThreadPoolUtil.execute {
            var userConfig =
                AppDataBase.getInstance().userConfigDao().findByLeanCloudUserId(personId)
            if (userConfig == null) { //创建第一个用户配置--使用默认数据目录
                userConfig = UserConfig.newItem(
                    personId,
                    UserConfigConstants.VALUE_DEFAULT_DB_FOLDER
                )
                AppDataBase.getInstance().userConfigDao().save(userConfig)
            }

            //存储新的项目
            ProjectDb.getInstance().save(
                ProjectRecord(
                    projectId,
                    "哈哈工程",
                    CoordinateSystem.newCoordinateSystem(App.instance.applicationContext),
                    Date().time
                ).apply {
                    author = "张哈哈"
                }
            )
            var currentProjectConfig =
                KeyValueDb.getInstance().findData(KeyValueConstants.KEY_CURRENT_PROJECT_ID)
            if (currentProjectConfig != null) {
                currentProjectConfig.value = projectId
            } else {
                currentProjectConfig =
                    KeyValueRecord(KeyValueConstants.KEY_CURRENT_PROJECT_ID, projectId)
            }
            KeyValueDb.getInstance().save(currentProjectConfig)
        }

    }

    fun logout() {

    }
}