package com.project.survey.util;

import android.content.Context;

import com.hjq.permissions.OnPermissionCallback;
import com.hjq.permissions.Permission;
import com.hjq.permissions.XXPermissions;

import java.util.List;

import blankj.utilcode.util.ToastUtils;

public class StoragePermissionUtils {
    public static void checkStoragePermission(Context context, Runnable onGetPermissionCallback) {
        XXPermissions.with(context)
                .permission(Permission.MANAGE_EXTERNAL_STORAGE)
                .request(new OnPermissionCallback() {
                    @Override
                    public void onGranted(List<String> permissions, boolean all) {
                        if (onGetPermissionCallback != null) {
                            onGetPermissionCallback.run();
                        }
                    }

                    @Override
                    public void onDenied(List<String> permissions, boolean never) {
                        if (never) {
                            ToastUtils.showShort("请手动授予文件读写权限");
                            // 如果是被永久拒绝就跳转到应用权限系统设置页面
                            XXPermissions.startPermissionActivity(context, permissions);
                        } else {
                            checkStoragePermission(context, onGetPermissionCallback);
                        }
                    }
                });
    }
}
