package com.project.survey.widget

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import androidx.appcompat.widget.LinearLayoutCompat
import com.project.survey.R
import com.project.survey.databinding.WidgetSectionItemBinding
import com.project.survey.extend.isVisibleOrGone

class SectionItemWidget @JvmOverloads constructor(
    context: Context,
    val attrs: AttributeSet? = null,
    defStyleAttr: Int = 0
) : LinearLayoutCompat(context, attrs, defStyleAttr) {

    private val binding: WidgetSectionItemBinding

    init {
        binding = WidgetSectionItemBinding.inflate(LayoutInflater.from(context), this, true)
        val typeArray = context.obtainStyledAttributes(attrs, R.styleable.SectionItemWidget)

        val icon = typeArray.getResourceId(R.styleable.SectionItemWidget_siw_icon, -1)
        binding.ivIcon.setImageResource(icon)

        binding.tvName.text = typeArray.getString(R.styleable.SectionItemWidget_siw_name)

        typeArray.recycle()
    }

    /**
     * 设置未读数
     */
    fun setBadge(count: Int): SectionItemWidget = apply {
        binding.tvBadge.isVisibleOrGone(count > 0)
        binding.tvBadge.text = "$count"
    }
}