package com.project.survey.widget.edittext;


import android.content.Context;
import android.text.method.HideReturnsTransformationMethod;
import android.text.method.PasswordTransformationMethod;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.RelativeLayout;

import com.project.survey.R;

public class PasswordView extends RelativeLayout {

    private EditText etPwd;
    private ImageView ivPwdShowHide;

    public PasswordView(Context context, AttributeSet attrs) {
        super(context, attrs);
        init(context);
    }

    public PasswordView(Context context) {
        super(context);
        init(context);
    }

    private void init(Context context) {
        LayoutInflater.from(context).inflate(R.layout.view_password, this, true);
        etPwd = findViewById(R.id.etPwd);
        View pwdShowHide = findViewById(R.id.pwdShowHide);
        ivPwdShowHide = findViewById(R.id.ivPwdShowHide);

        pwdShowHide.setOnClickListener(v -> {
            ivPwdShowHide.setSelected(!ivPwdShowHide.isSelected());

            if (ivPwdShowHide.isSelected()) {
                etPwd.setTransformationMethod(HideReturnsTransformationMethod.getInstance());
            } else {
                etPwd.setTransformationMethod(PasswordTransformationMethod.getInstance());
            }
            etPwd.setSelection(etPwd.getText().length());
        });
    }

    public String getText() {
        return etPwd.getText().toString().trim();
    }

    public void clearEtPwdText() {
        etPwd.setText("");
    }

}