package com.bingce

import org.gradle.api.Project
import java.io.FileInputStream
import java.util.*

class ModuleName(project: Project) {
    private val useAAR: String
    private val useBaseAAR: String

    init {
        val properties = ConfigProperties(project)
        useAAR = properties.getProperty("useAAR") ?: "true"
        useBaseAAR = properties.getProperty("useBaseAAR") ?: "true"
    }

    fun bingceModule(name: String): String {
        return if ("base" == name) {
            if ("false" == useBaseAAR) {
                ":bingce:base"
            } else {
                ":aar:base"
            }
        } else {
            if ("false" == useAAR) {
                ":bingce:$name"
            } else {
                ":aar:$name"
            }
        }
    }

    fun openSourceModule(name: String): String {
        return if ("false" == useAAR) {
            ":opensource:$name"
        } else {
            ":aar:$name"
        }
    }

    fun isUseAAR(): Boolean {
        return useAAR == "true"
    }
}