package org.polaric.colorful;

import android.app.Dialog;
import android.content.Context;
import android.os.Bundle;
import androidx.recyclerview.widget.GridLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import androidx.appcompat.widget.Toolbar;
import android.view.View;

import color.Rdrawable;
import color.Rid;
import color.Rlayout;
import color.Rstring;

public class ColorPickerDialog extends Dialog implements View.OnClickListener, ColorPickerAdapter.OnItemClickListener {
    private RecyclerView recycler;
    private Toolbar toolbar;
    private OnColorSelectedListener listener;

    public ColorPickerDialog(Context context) {
        super(context);
    }

    @Override
    public void onClick(View view) {
        dismiss();
    }

    @Override
    public void onItemClick(Colorful.ThemeColor color) {
        dismiss();
        if (listener!=null) {
            listener.onColorSelected(color);
        }
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(Rlayout.dialog_colorpicker());

        recycler = ((RecyclerView) findViewById(Rid.colorful_color_picker_recycler()));
        toolbar = ((Toolbar) findViewById(Rid.colorful_color_picker_toolbar()));

        toolbar.setNavigationOnClickListener(this);
        toolbar.setBackgroundColor(getContext().getResources().getColor(Colorful.getThemeDelegate().getPrimaryColor().getColorRes()));
        toolbar.setTitle(Rstring.select_color());

        toolbar.setNavigationIcon(Rdrawable.ic_arrow_back_white_48px());
        recycler.setLayoutManager(new GridLayoutManager(getContext(), 4));
        ColorPickerAdapter adapter = new ColorPickerAdapter(getContext());
        adapter.setOnItemClickListener(this);
        recycler.setAdapter(adapter);
    }

    public interface OnColorSelectedListener {
        void onColorSelected(Colorful.ThemeColor color);
    }

    public void setOnColorSelectedListener(OnColorSelectedListener listener) {
        this.listener=listener;
    }
}
