//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package com.project.survey.ui.pointmeasure.measure.util;

import android.content.Context;
import android.widget.ImageView;
import android.widget.TextView;

import com.bingce.coordlib.util.CoordUtil;
import com.bingce.device.Device;
import com.bingce.device.enums.DeviceTypeEnum;
import com.bingce.rtk.command.RTK;
import com.bingce.rtk.gnss.Gnss;
import com.bingce.surveyor.util.dialog.CustomDialog;
import com.bingce.surveyorBase.R.string;
import com.bingce.utils.Util;
import com.project.survey.databinding.ActivityBaseSurveyNewBinding;
import com.project.survey.databinding.LayoutBaseSurveyStakingSettingBinding;
import com.project.survey.util.DeviceConnectUtil;

import blankj.utilcode.util.ToastUtils;
import lecho.hellocharts.view.LineChartView;

public class SurveyToolBarClickListenerUtils {
    public SurveyToolBarClickListenerUtils() {
    }

    public static void setOnClickListener(Context context, boolean isShowSettingConnectTipsDialog,
                                          boolean isStakingPager, ActivityBaseSurveyNewBinding activityBaseSurveyBinding,
                                          LayoutBaseSurveyStakingSettingBinding stakingSettingBinding,
                                          IToolBarClickListener callBack) {
        stakingSettingBinding.llSet.setOnClickListener((v) -> {
            if (isShowSettingConnectTipsDialog) {
                if (DeviceConnectUtil.isDeviceConnectSelectDialog(context, activityBaseSurveyBinding)) {
                    callBack.onSettingClickListener();
                }
            } else {
                callBack.onSettingClickListener();
            }

        });
        stakingSettingBinding.rlPositionCenter.setOnClickListener((v) -> {
            if (isStakingPager) {
                callBack.onPositionCenterClickListener();
            } else if (DeviceConnectUtil.isDeviceConnectSelectDialog(context, activityBaseSurveyBinding)) {
                callBack.onPositionCenterClickListener();
            }

        });
        stakingSettingBinding.rlFullScreen.setOnClickListener((v) -> {
            callBack.onFullScreenClickListener();
        });
        stakingSettingBinding.rlTiltPrimAuto.setOnClickListener((v) -> {
            if (DeviceConnectUtil.isDeviceConnectSelectDialog(context, activityBaseSurveyBinding)) {
                if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_TS) {
                    callBack.onAutoPrimsClickListener();
                } else {
                    if (!Gnss.getInstance().getDevice().isSupportTilt()) {
                        ToastUtils.showShort(string.current_device_not_support_tilt);
                        return;
                    }

                    if (Gnss.getInstance().getDevice().isTiltOpen()) {
                        RTK.getInstance().sendCloseTiltCmd();
                    } else if (Device.getInstance().remindAntBeforeTilt) {
                        (new CustomDialog.Builder(context)).setTitle(context.getString(string.prompt)).setContent(context.getString(string.current_ploe_high_lever) + context.getString(string.colon) + CoordUtil.formatDouble2String(Gnss.getInstance().getDevice().getPoleHeight(), 3) + "m\n" + context.getString(string.check_whether_pole_height_correct)).setButtonConfirm((v1) -> {
                            RTK.getInstance().sendOpenTiltCmd();
                        }).create().show();
                    } else {
                        RTK.getInstance().sendOpenTiltCmd();
                    }
                }
            }

        });
    }

    public static void setScaleViewOnClickListener(LineChartView lineChartView, TextView tvScale, ImageView ivScale) {
        lineChartView.setViewportChangeListener((viewport) -> {
            if (!Double.isNaN(viewport.left) && !Double.isNaN(viewport.right) && !Double.isNaN(viewport.top) && !Double.isNaN(viewport.bottom)) {
                double width = Math.abs(viewport.left - viewport.right);
                int chartViewWidth = lineChartView.getWidth();
                int scaleViewWith = ivScale.getWidth();
                double value = width / (double) chartViewWidth * (double) scaleViewWith;
                String string;
                if (value > 1.0) {
                    string = Util.formatDouble2String(value, 1) + "m";
                } else {
                    string = Util.formatDouble2String(value, 3) + "m";
                }

                tvScale.setText(string);
            } else {
                tvScale.setText("*");
            }
        });
    }

    public interface IToolBarClickListener {
        void onSettingClickListener();

        void onPositionCenterClickListener();

        void onFullScreenClickListener();

        void onAutoPrimsClickListener();
    }
}
