//
// Source code recreated from a .class file by IntelliJ IDEA
// (powered by FernFlower decompiler)
//

package com.project.survey.util;

import android.view.View;

import androidx.fragment.app.FragmentActivity;

import com.bingce.device.Device;
import com.bingce.device.enums.DeviceTypeEnum;
import com.bingce.rtk.gnss.Gnss;
import com.bingce.totalstation.TotalStation;
import com.bingce.utils.SoundPoolUtil;
import com.project.survey.R;
import com.project.survey.databinding.LayoutBaseSurveyStakingSettingBinding;
import com.project.survey.databinding.LayoutDraggingButtonBinding;
import com.project.survey.databinding.LayoutPoleHrHeightBinding;

import blankj.utilcode.util.StringUtils;
import blankj.utilcode.util.Utils;

public class SurveyUIUtils {
    public SurveyUIUtils() {
    }

    public static void stopSoundPool() {
        SoundPoolUtil.getInstanceUsageMedia().stop();
    }

    private static int dip2px(float dpValue) {
        float scale = Utils.getApp().getResources().getDisplayMetrics().density;
        return (int) (dpValue * scale + 0.5F);
    }

    public static void updatePoleHrHeightDraggingToolBarLayout(FragmentActivity activity, boolean isExpand, LayoutPoleHrHeightBinding layoutPoleHrHeightBinding,
                                                               LayoutDraggingButtonBinding layoutDraggingButtonBinding,
                                                               LayoutBaseSurveyStakingSettingBinding layoutBaseSurveyStakingSettingBinding,
                                                               boolean isJudgeIvSettingStatus, boolean isStakingPager, Object currentCoordinate) {
        SurveyDevicePoleHrHeightUtils.initDevicePoleHrHigh(activity, layoutPoleHrHeightBinding);
        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_TS) {
            layoutDraggingButtonBinding.drWatchSurvey.setVisibility(View.VISIBLE);
            if (isStakingPager) {
                layoutDraggingButtonBinding.drWatchSurveyRecord.setText(StringUtils.getString(R.string.record));
            } else {
                layoutDraggingButtonBinding.drWatchSurveyRecord.setText(StringUtils.getString(R.string.measure_and_record));
            }
        } else {
            layoutDraggingButtonBinding.drWatchSurvey.setVisibility(View.GONE);
            layoutDraggingButtonBinding.drWatchSurveyRecord.setText(StringUtils.getString(R.string.record));
        }

        layoutBaseSurveyStakingSettingBinding.expandLayout.setRetractHeight((float) dip2px(25.0F));
        layoutBaseSurveyStakingSettingBinding.expandLayout.initExpand(isExpand);
        layoutBaseSurveyStakingSettingBinding.llTopTool.setOnClickListener((v) -> {
            if (layoutBaseSurveyStakingSettingBinding.expandLayout.isExpand()) {
                layoutBaseSurveyStakingSettingBinding.ivTool.setImageResource(R.mipmap.icon_new_up_gray_arrow);
            } else {
                layoutBaseSurveyStakingSettingBinding.ivTool.setImageResource(R.mipmap.icon_new_down_gray_arrow);
            }

            layoutBaseSurveyStakingSettingBinding.expandLayout.toggleExpand();
        });
        if (isJudgeIvSettingStatus) {
            if (!Device.getInstance().isDeviceConnected()) {
                layoutBaseSurveyStakingSettingBinding.ivSurveySetting.setImageResource(R.drawable.icon_survey_setting_gray);
            } else {
                layoutBaseSurveyStakingSettingBinding.ivSurveySetting.setImageResource(R.drawable.icon_survey_setting_black);
            }
        } else {
            layoutBaseSurveyStakingSettingBinding.ivSurveySetting.setImageResource(R.drawable.icon_survey_setting_black);
        }

        if (!Device.getInstance().isDeviceConnected() && currentCoordinate == null) {
            layoutBaseSurveyStakingSettingBinding.ivPositionCenter.setImageResource(R.drawable.icon_survey_position_center_gray);
            layoutBaseSurveyStakingSettingBinding.tvPositionCenter.setTextColor(activity.getColor(R.color.color_BCBCBC));
        } else {
            layoutBaseSurveyStakingSettingBinding.ivPositionCenter.setImageResource(R.drawable.icon_survey_position_center_black);
            layoutBaseSurveyStakingSettingBinding.tvPositionCenter.setTextColor(activity.getColor(R.color.black));
        }

        if (isStakingPager) {
            layoutBaseSurveyStakingSettingBinding.rlInputCurrentPoint.setVisibility(View.VISIBLE);
        } else {
            layoutBaseSurveyStakingSettingBinding.rlInputCurrentPoint.setVisibility(View.GONE);
        }

        if (Device.getInstance().deviceType == DeviceTypeEnum.DEVICE_TYPE_TS) {
            if (isStakingPager) {
                layoutBaseSurveyStakingSettingBinding.rlTiltPrimAuto.setVisibility(View.VISIBLE);
            } else {
                layoutBaseSurveyStakingSettingBinding.rlTiltPrimAuto.setVisibility(View.GONE);
            }

            if (Device.getInstance().isDeviceConnected() && TotalStation.getInstance().isSupportMotor()) {
                layoutBaseSurveyStakingSettingBinding.ivTiltPrimAuto.setImageResource(R.drawable.icon_auto_look_prim_black);
                layoutBaseSurveyStakingSettingBinding.tvTiltPrimAuto.setTextColor(activity.getColor(R.color.black));
            } else {
                layoutBaseSurveyStakingSettingBinding.ivTiltPrimAuto.setImageResource(R.drawable.icon_auto_look_prim_gray);
                layoutBaseSurveyStakingSettingBinding.tvTiltPrimAuto.setTextColor(activity.getColor(R.color.color_BCBCBC));
            }

            layoutBaseSurveyStakingSettingBinding.tvTiltPrimAuto.setText(activity.getString(R.string.auto_turn));
        } else {
            if (Gnss.getInstance().getDevice().isTiltOpen() && Gnss.getInstance().getDevice().isSupportTilt()) {
                layoutBaseSurveyStakingSettingBinding.ivTiltPrimAuto.setImageResource(R.drawable.icon_survey_tilt_black);
                layoutBaseSurveyStakingSettingBinding.tvTiltPrimAuto.setTextColor(activity.getColor(R.color.black));
            } else {
                layoutBaseSurveyStakingSettingBinding.ivTiltPrimAuto.setImageResource(R.drawable.icon_survey_tilt_gray);
                layoutBaseSurveyStakingSettingBinding.tvTiltPrimAuto.setTextColor(activity.getColor(R.color.color_BCBCBC));
            }

            layoutBaseSurveyStakingSettingBinding.tvTiltPrimAuto.setText(activity.getString(R.string.tilt));
            layoutBaseSurveyStakingSettingBinding.rlTiltPrimAuto.setVisibility(View.VISIBLE);
        }

    }
}
